;: Title: AMPL Script Editor
#Include %A_ScriptDir%\includes\AddGraphicButton.ahk
#Include %A_ScriptDir%\includes\DLG_FileOpenSave.ahk
#Include %A_ScriptDir%\includes\ScriptEditorFunctions.ahk
#Include %A_ScriptDir%\includes\Anchor.ahk

#NoEnv

thisScript_Name=AMPL Script Editor
thisScript_Version=0.4.9
version_ScriptEditor:=thisScript_Version
thisScript_VersionDate=2009.10.12
thisScript_AuthorName=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

version_ScriptEditor_Package=0.5.2

requiredVerion=1.0.47.05

/* 	AMPL Script Editor Package
**********************************************************
**  Script Editor Package 2009.10.09  0.5.2
**********************************************************
**  ScriptEditor.ahk			2009.07.02	0.4.9
**  ScriptEditorFunctions	2009.10.06  0.1.5
**  AMPLRecorder.ahk      2009.10.09  0.19.0
**  ScriptUpdate.ahk      2009.10.12  0.1.2
** 	AMPL_Includes.ahk     2009.07.02  0.4.1
**  Recorder.ahk          2009.10.06  1.9.0
**	AddGraphicButton.ahk  2009.04.24  2.2.1
**********************************************************
*/
/*
**********************************************************************************
** 	Version History
**********************************************************************************
**  0.4.x
**    todo: when calling add function from include library it should IfLabel("AddFunction") gosub, AddFunction: which returns the new text to add to the window
**    todo: Add CheckBox=Close as Group
**    todo: Add CheckBox=Confirmation
**    todo: Add Edit=Confirmation Timeout
**    todo: Add cmd_CloseAsGroup to each step
**          if cmd_CloseAsGroup=1
**            numProc=%closeAsGroup_List0% + 1
**            closeAsGroup_List%numProc%=%ampl_PID%
**          waitFoxGroupClose( arrayName ) {
**            temp.ahk={
**              for each PID in ArrayName
**                If not Process, Exest, PID
**                  Close all?
**							}
**            write temp.ahk
**            run temp.ahk
**						}
**  0.4.9 2009.10.12
**    ! Simple Window was not saving script: Fixed
**  0.4.8 2009.10.06
**    + Added ability to add code to codeAfter in AddFunctionText()
**    ! MessageFrame text for MessageFrame fixed typo
**    + Alt-Generate SavesAs the script
**    + Added Anchors for window resizing
**    + Added Simple and Advanced Script window
**    + Use Recorder.ahk as macro recorder
**  0.4.7 2009.09.14
**    ! Fixed path issues when starting Settings.ahk
**    + CNTL+GrabWindowDetails will NOT run the command.
**    + Run button added for codeAfter
**    + CNTL+TestScript runs actual script (not temp): This is useful for schedule scripts which will write the shortcut then exit.
**    + New Plugin Format for the Insert Into codeBefore
**	0.4.6 2009.07.02
**		! Fixed pasting of steps & their Icons
**	0.4.5 2009.06.25
**		+ Blank coordinates use window's current.
**		+ SHIFT + Grab Details grabs winText as well
**		+ winText, winExText, winExTitle variables added
**		+ Add settings button to About
**		+ SHIFT about opens settings
**		! Fixed loading cmd_WorkingDirectory from existing script
**	0.4.4 2009.06.22
**		! Corrected VariableToAdd strings
**		! Corrected rollovers
**	0.4.3 2009.06.14
**		^ Common functions moved to ScriptEditorFunctions.ahk
**		+ ScriptUpdate.ahk used to update scripts
**		+ Dropdown containing script variables: Need to fix up the rollovers
**		+ Update Mode
**	0.4.2 2009.06.04
**		^ Check Save on exit  [http://www.mitupela.net/scribbly/mantis/view.php?id=23]
**	0.4.1 2009.06.03
**		! Added link details to Grab Details [http://www.mitupela.net/scribbly/mantis/view.php?id=24]
**		Note: Doesn't to minMax
**	0.4.0
**		+ Link Files will now load the link details:
**			+ Command
**			+ Parameters
**			+ Working Directory
**			+ WinMinMax
**			+ Comment
**		+ Added Variables that can be manually changed by user:
**			+ var_waitPostRun
**			+ var_WinWaitSeconds
**		+ Version Check
**	0.3.5 2009.05.14
**		^ icons & ini for othes file types: icons with only 32 & 24 sized images
**		+ Info dialog
**	0.3.4 2009.05.13
**		+ cmdNone inactivates all window commands
**		+ cmdWait inactivates all window commands
**		+ edit and load code buttons
**		+ check for code being externally edited
**	0.3.3 2009.05.06
**		+ Extended actionWhat commands
**		+ msgbox timeOut added (per step)
**		+ roll-overs for all objects
**		+ Check for GetWindowDetails
**		+ SHIFT+GetCommand opens fileSelectFolder
**		+ SHIFT+GetParameter opens fileSelectFolder
**	0.3.2 2009.04.30
**		+ check for script changes
**		+ Add error msgbox setting per Step
**		+ ampl_ProcessCommand returnrsthe sum of errors
**		+ new actionWhen:=ERROR (<100) [Fail>100]
**		^ check Changes improved: now checks actual changed fields (not countind changes made): that way a change from and then back to the original would count as 0 change
**	0.3.1 2009.04.27
**		! Fixed ListView icons moving correctly when rearranging LV
**	0.3.0 2009.04.25
**		+ Load existing Script
**		+ Graphic Buttons for Step window
**		+ Cut step
**	0.2.7 2009.04.20
**		! Use window ID now for all following actions
**		+ Implemented Window Spy
**		+ Implemented Script Writer
**		^ Save checks for command='' and cmdNone=0
**	0.2.6 2009.03.30
**		^ Paste step now includes the icon
**		! Paste into empty script now works correctly.
**	0.2.5 2009.03.28
**		~ Step window is positioned over the AMPL window
**		+ Added RunWait
**		~ Progress bar progresses
**		~ Message Frame says things
**	0.2.4 2009.03.27
**		+ Default settings
**		~ MoveDo & SizeDo are not enabled by default
**		! GetDetails enables MoveDo & SizeDo
**	0.2.3 2009.03.24
**		! Fixed Step movements
**		! Fixed icon on Edit Step
**	0.2.2 2009.03.23
**		+ Paste Step
**		^ Added actionWhen, actionWhat, actionForce
**	0.2.1 2009.03.21
**		+ Delete Step
**		+ Demote Step
**		+ Promote Step
**		+ Copy Step
**	0.2.0
**		+ Edit existing script
**		+ field roll-over messages
**	0.1.7
**		~ Cosmetic changes and code cleaning
**	0.1.6
**		+ fileName (for ini)
**		+ waitForTimeOut
**		+ non-programme icons
**		~ Name change from "Creator" to "Editor"
**	0.1.5
**		+ Graphic Buttons
**	0.1.4 17/1/2009
**		Script Elements Added:
**			+ codeBefore
**			+ waitFor
**			+ TAB Control for custom code
**	0.1.3
**		Script Elements Added:
**			+ winTitle
**			+ winClass
**	0.1.2
**	0.1.1
**	0.1.0
*/

if (A_AhkVersion < requiredVerion)
	{
  versionMessage=AMPL Script Editor requires at least v%requiredVerion%`nPlease upgrade you version of AHK!
	MsgBox, Your version of AutoHotKey is %A_AhkVersion%`n`n%versionMessage%
  ExitApp, 10
	}

;SplitPath, A_SCRIPTDIR, , amplDirectory, , ,
;SplitPath, A_AhkPath, , ahkDirectory, , ,

newScriptName=UnNamed
blank=
scriptName=
; get arguments
if (%0%>0){
scriptName = %1%
if(2!=)
	{
		ampldirectory = %2%
	}
}else{
	scriptName:=newScriptName
}

if version_AMPL_Includes_Installed=Not Installed
{
  MsgBox, Can't find Includes!`nI'm not sure what that means yet... but give me time...
}

DetectHiddenWindows, on
; Script Fields
script_Version=0

; Script Step Fields Defaults
def_MoveDo=0
def_MoveX=0
def_MoveY=0
def_SizeDo=0
def_SizeW=0
def_SizeH=0
def_delayBefore=0
def_delayAfter=0
def_minmaxAfter=0
def_stepTitle=
def_cmdPath=
def_cmdParameter=
def_cmdProcess=
def_codeBefore=
def_cmdRunWait=0
def_codeAfter=
def_MinMaxAfter=1
def_waitFor=1
def_waitForTimeOut=0
def_actionWhat=1
def_actionWhen=1
def_actionForce=0
def_actionTimeOut=0
def_CmdNone=0
def_msgShow=0
def_msgTimeOut=0
def_winTitle=
def_winText=
def_winExTitle=
def_winExText=
def_winClass=
def_GetFileParameter=
def_LargeIcon=
def_iconPath=
def_iconListViewNumber=1

; Step Window Variables
MessageFrame=
EditCB=
editingCB:=false
EditCA=
editingCA:=false
gotWinDetails=0
GetCmd=
windowStepCreated=0
AddV=
VariableToAdd=
run_PID=
win_PID=
xwinTitleCheck=
xwinClassCheck=
run_PIDCheck=
cmdProcessCheck=
fileNameCheck=
win_PIDCheck=
stepTabs=
noCmd_Label=
runWait_Label=
action_Label=
waitForTimeOut_Label=
waitFor_Label=
codeAfter_Label=
RunCA=
cmdProcess_Label=
fileName_Label=
win_PID_Label=
cmdProcessCheck_Label=
fileNameCheck_Label=
win_PID_Check_Label=
CheckWindow=

; Simple Window
scriptName_Simple=
RunScript_Simple=
GenerateScript_Simple=
MessageFrame_Simple=
ProgressBar_Simple=

windowInfoCreated=0
windowMainCreated=0
windowSimpleCreated=0

;iconListViewNumber=0                 ; icon for the listview
CommandBeingEdited=0      ;
GrabDetails=
scriptHasChanged=0
scriptHasBeenWritten=0
doCut:=false
backSlash=\
GetFunction_Text:=""

; settings
useLargeIcons=1 					; 0=small,1=Large

amplIcon = %amplDirectory%\AMPL.ico
startIcon=%amplDirectory%\icons\Buuf\Script_Edit.ico    ; Initial icon for a scriptStep

; Tray menu & icon
Menu, tray, icon, %amplIcon%

; Load non-programme icon settings
iconsFileTypes=
; Loop through the icon files on the system
Loop, %A_ScriptDir%\icons\filetypes\*.ico, , 0  ; Recurse into subfolders.
{
	; Check the ini for what extensions to use this for
	IniRead, extensions, %A_ScriptDir%\ScriptEditor.ini, filetypes, %A_LOOPFILENAME%
	if( extensions <> "ERROR" and extensions <> "" )
	  {
	    ;record=graphic.ico|jpg|png|bmp
			iconsFileTypes=%iconsFileTypes%%A_LOOPFILENAME%|%extensions%|`n
		}
}
scriptEditor=
IniRead, scriptEditor, %A_ScriptDir%\ScriptEditor.ini, editor, ahk, notepad.exe
IniRead, useLogging, %A_ScriptDir%\ScriptEditor.ini, defaults, logging, 0
IniRead, usewaitPostRun, %A_ScriptDir%\ScriptEditor.ini, defaults, waitPostRun, 0
IniRead, useWinWaitPID, %A_ScriptDir%\ScriptEditor.ini, defaults, WinWaitPID, 5
IniRead, useWinWaitCLASS, %A_ScriptDir%\ScriptEditor.ini, defaults, WinWaitCLASS, 2
IniRead, useWinWaitTITLE, %A_ScriptDir%\ScriptEditor.ini, defaults, WinWaitTITLE, 1
IniRead, useEditorWindow, %A_ScriptDir%\ScriptEditor.ini, defaults, editorwindow, 3

; Load the Library Plugins
countLibrary=0
Loop
{
	IniRead, prefixLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, prefix, 
	IniRead, labelLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, label, 
	IniRead, functionLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, functions, 
	IniRead, includeLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, includes, 
	IniRead, enableLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, enabled, 
	
	if enableLibrary=1
	{
		countLibrary+=1
		listPreFix%countLibrary%:=prefixLibrary
		listPlugins.= labelLibrary . "|"
		functionToCall:= prefixLibrary . "_Init"
		success:=%functionToCall%()
		if success!=0
      MsgBox, Error loading %labelLibrary%
	}
	If prefixLibrary = ERROR
		break
}
listPreFix0:=countLibrary

Gosub, GetMonitors

; Load a scriptFile if there's something to load
if (ampldirectory!=blank and scriptName!=newScriptName )
 {
		; load existing file here
		scriptPath=%ampldirectory%\scripts\%scriptName%
    IfExist, %scriptPath%
      {
			 Gosub, createMainWindow
			 windowMainCreated=1
			 script_loadedSteps:=LoadFile( scriptPath )
			 script_cmd:=ERRORLEVEL
			 gui, Hide
			}
 } else {
    script_loadedSteps=0
}
; Script Editor Gui
ampl_Editor_SIMPLE=2
ampl_Editor_ADVANCED=1
ampl_Editor_ASK=3
useEditor:=ampl_Editor_ADVANCED
; ToDo: Add logic for script_loadedSteps=1 and editorDefault=ampl_Editor_SIMPLE
; show simpleEditor
; else i
use_Toggle=0
if (script_loadedSteps=1 && script_cmd="NoCmd")
{
	if (useEditorWindow=ampl_Editor_SIMPLE)
	{
		useEditor:=ampl_Editor_SIMPLE
	}
	else if (useEditorWindow=ampl_Editor_ASK)
		{
		  useEditor:=ampl_Editor_SIMPLE
      MsgBox, 4, thisScript_Name, This script only has one step: Did you want to load the simple Editor?, 10
      IfMsgBox, No
        useEditor:=ampl_Editor_ADVANCED
		}
	use_Toggle:=1
} else if script_loadedSteps=0
{
		use_Toggle=1
}
if (useEditor=ampl_Editor_ADVANCED)
{
	Gosub, createMainWindow
	Gosub, ShowMainWindow
	;GUI, Show
	windowMainCreated=1
	ampl_CurrentWindow:=ampl_Editor_ADVANCED
} else
{
	Gosub, createSimpleWindow
	GUI, 4: Show
	gui, 4: +LastFound
  WinGet, ampl_SimpleWindow , ID
	windowSimpleCreated=1
	ampl_CurrentWindow:=ampl_Editor_SIMPLE
}

if script_loadedSteps>0
{
	if (ampl_CurrentWindow=ampl_Editor_ADVANCED)
	{
    Gosub, DrawMainWindow
  } else {
	  codeA:=GetField( commandList , #codeAfter ,characterSeparator)
	  StringReplace, codeA, codeA,|, `n, All
    GuiControl,4: , codeAfter_Simple , %codeA%
	}
}
if (ampl_CurrentWindow=ampl_Editor_ADVANCED)
	SetTimer, WatchCursorMain , 100

Return
#Include %A_ScriptDir%\includes\Plugins.ahk




4guiclose:
guiclose:
Gosub, checkSave
ExitApp
return

checkSave:
	if(scriptHasChanged>0) {
    MsgBox, 4, Title, %scriptName% has changed: save?,
    IfMsgBox, Yes
      Gosub, %SaveHere%
	}
Return

DoSomething:
msgbox, Do Something Here
Return

GetMonitors:
; Get Monitors
; Monitors are used in the window move section
SysGet, countMonitor, MonitorCount
SysGet, primaryMonitor, MonitorPrimary
;selectMonitor=
coordsMonitor=
Loop, %countMonitor%
{
 SysGet, tmpMonitorName, MonitorName, %A_INDEX%
 ;, %tmpMonitorName%
 if(SubStr(tmpMonitorName, 1, 4)="\\.\")
   StringTrimLeft, tmpMonitorName, tmpMonitorName, 4
 selectMonitor=%selectMonitor%%tmpMonitorName%|
 if primaryMonitor=%A_INDEX%
    selectMonitor=%selectMonitor%|
 SysGet, tmpMonitorArea, MonitorWorkArea, %A_INDEX%
 coordsMonitor=%coordsMonitor%%tmpMonitorAreaLeft%%characterSeparator%%tmpMonitorAreaTop%%characterSeparator%%tmpMonitorAreaRight%%characterSeparator%%tmpMonitorAreaBottom%`n
}
; remove trailing character
StringTrimRight, selectMonitor, selectMonitor, 1
Return

ToggleWindow:
if (ampl_CurrentWindow=ampl_Editor_ADVANCED)
{
  WinGetPos , X, Y, , , ahk_id %ampl_MainWindow%
  GuiControlGet, scriptName_Simple , , scriptName,
  if LV_GetCount()=0
  {
		commandObject := "New Step " (LV_GetCount() + 1)       ; Title
			. characterSeparator . def_cmdProcess                ; fileName
			. characterSeparator . def_delayBefore               ; delayBefore
			. characterSeparator . def_cmdPath                   ; cmdPath
			. characterSeparator . def_cmdParameter              ; cmdParameters
			. characterSeparator . def_cmdRunWait                ; cmdParameters
			. characterSeparator . def_cmdProcess                ; procedureName
			. characterSeparator . def_delayAfter                ; delayAfter
			. characterSeparator . def_MoveDo                    ; doMove
			. characterSeparator . def_MoveX                     ; moveX
			. characterSeparator . def_MoveY                     ; moveY
			. characterSeparator . def_SizeDo                    ; doSize
			. characterSeparator . def_SizeW                     ; sizeW
			. characterSeparator . def_SizeH                     ; sizeH
			. characterSeparator . def_minmaxAfter               ; minmaxAfter
			. characterSeparator . def_waitFor                   ; waitFor
			. characterSeparator . def_waitForTimeOut            ; waitForTimeOut
			. characterSeparator . def_actionWhen                ; actionWhen
			. characterSeparator . def_actionWhat                ; actionWhat
			. characterSeparator . def_actionForce               ; actionForce
			. characterSeparator . def_actionTimeOut             ; actionForce
			. characterSeparator . def_codeBefore                ; codeBefore
			. characterSeparator . def_codeAfter                 ; codeAfter
			. characterSeparator . def_winTitle                  ; windowTitle
			. characterSeparator . def_winClass                  ; windowClass
			. characterSeparator . def_iconListViewNumber        ; iconNumber
			. characterSeparator . def_iconPath                  ; iconLarge
			. characterSeparator . 1                 						 ;
			. characterSeparator . def_msgShow
			. characterSeparator . def_msgTimeOut

	commandList = %commandList%%commandObject%`n
	scriptHasChanged+=1

	}
	Gui,1: Hide
	if windowSimpleCreated=0
		Gosub, createSimpleWindow
	gui, 4: Default

  codeA:=GetField( commandList , #codeAfter ,characterSeparator)

  StringReplace, codeA, codeA,|, `n, All
  GuiControl, , codeAfter_Simple , %codeA%
  GuiControl, , scriptName_Simple, %scriptName_Simple%
	GUI, 4: Show, x%x% y%y%
	windowSimpleCreated=1
	ampl_CurrentWindow:=ampl_Editor_SIMPLE
	ampl_ReturnWindow:=4
} else
{
  WinGetPos , X, Y, , , ahk_id %ampl_SimpleWindow%
  GuiControlGet, scriptName , , scriptName_Simple,
	gui, 4: submit
  StringReplace, codeAfter_Simple, codeAfter_Simple,`n, |, All
  commandList:=UpdateField(commandList,#codeAfter,codeAfter_Simple, characterSeparator)
	if windowMainCreated=0
		gosub, createMainWindow
	gui,1: Default
  GuiControl, , scriptName, %scriptName%
  Gosub, ShowMainWindow
	GUI, Show, x%x% y%y%
  Gosub, DrawMainWindow
	windowMainCreated=1
	ampl_CurrentWindow:=ampl_Editor_ADVANCED
	ampl_ReturnWindow:=1
	SetTimer, WatchCursorMain , 100

}
Return

/*
** ********************************************************************************
** Main Window - Advanced Routines
** ********************************************************************************
*/

createMainWindow:
if windowMainCreated=1
	return
	
	Gui,1: Default
	Gui, Font, S12 CDefault Bold, Verdana
	Gui, Add, Text, x64 y20 w h , %thisScript_Name%
	Gui, Font, NORM s8,
	Gui, Add, Picture, x3 y3 w48 h48, %amplIcon%
	;AddGraphicButton("ToggleWindow", amplDirectory . "\scripteditor\icons\ok.ico", "x260 y20 w16 h16 gToggleWindow" , 16 , 16)
	gui, Add, Button,x235 y38 w60 h18 gToggleWindow vToggleWindow,Simple
  GuiControl, Show%use_Toggle%, ToggleWindow
	;GUI, Add, Picture, x301 y14 w32 gShowInfo, %amplDirectory%\icons\ScriptCreator\Info.ico
	AddGraphicButton("ShowInfo", amplDirectory . "\scripteditor\icons\info.ico", "x299 y3 w38 h38 gShowInfo" , 32 , 32)

	Gui, Font, S8 CDefault, Verdana
	Gui, Add, Text, x6 y60 w30 h20 , Title:
	Gui, Add, Edit, x40 y56 w256 h20 vscriptName , %scriptName%
	AddGraphicButton("RunScript", amplDirectory . "\scripteditor\icons\run.ico", "x299 y47 w38 h38 gRunScript" , 32 , 32)

	Gui, Add, ListView, x6 y80 r19 w290 vMyListView gMyListView , Step
	ImageListID:=IL_Create(10,10, useLargeIcons)
	success:=LV_SetImageList(ImageListID,1)
	AddGraphicButton("AddStep", amplDirectory . "\scripteditor\icons\add.ico", "x299 y99 w38 h38 gAddNewStep" , 32 , 32)
	AddGraphicButton("EditStep", amplDirectory . "\scripteditor\icons\edit.ico", "x299 y137 w38 h38 gEditStep" , 32 , 32)
	AddGraphicButton("DeleteStep", amplDirectory . "\scripteditor\icons\delete.ico", "x299 y175 w38 h38 gDeleteStep" , 32 , 32)
	AddGraphicButton("DemoteStep", amplDirectory . "\scripteditor\icons\movedown.ico", "x299 y213 w38 h38 gDemoteStep" , 32 , 32)
	AddGraphicButton("PromoteStep", amplDirectory . "\scripteditor\icons\moveup.ico", "x299 y251 w38 h38 gPromoteStep" , 32 , 32)
	AddGraphicButton("CopyStep", amplDirectory . "\scripteditor\icons\copy.ico", "x299 y289 w38 h38 gCopyStep" , 32 , 32)
	AddGraphicButton("PasteStep", amplDirectory . "\scripteditor\icons\paste.ico", "x299 y327 w38 h38 gPasteStep" , 32 , 32)
	AddGraphicButton("GenerateScript", amplDirectory . "\scripteditor\icons\save.ico", "x299 y370 w38 h38 gGenerate" , 32 , 32)
	gui, add, Text, x6 y377 w290 h20 vMessageFrame, Start by adding a step: (+)
	gui, add, progress, x6 y396 h10 w290 vProgressBar

	success:=IL_Add(ImageListID, startIcon)
	
return
ShowMainWindow:
	Gui, Show, x160 y122 , %thisScript_Name% %thisScript_Version%
	;Gui, Show, x160 y122 h410 w340, %thisScript_Name% %thisScript_Version%
	; Get the main window's Process ID for later use
	WinGet, ampl_MainWindow, ID, %thisScript_Name% %thisScript_Version%

	LV_ModifyCol()
	; Add HotKeys
	Hotkey, IfWinActive, %thisScript_Name% %thisScript_Version% ,
	Hotkey, ^a, AddNewStep
	Hotkey, ^+a, AddNewStep
	Hotkey, ^e, EditStep
	Hotkey, ^c, CopyStep
	Hotkey, ^v, PasteStep
	Hotkey, ^UP, PromoteStep
	Hotkey, ^DOWN, DemoteStep
	Hotkey, Delete, DeleteStep
	Hotkey ^i, ShowInfo
	Hotkey, ^+i, goSettings
	Hotkey, ^t, ToggleWindow
	ampl_ReturnWindow:=1
Return
DrawMainWindow:
   GuiControl, -ReDraw, MyListView
   LV_Delete()
   Loop, Parse, commandList,`n
   {
    if StrLen(A_LoopField)>0
       {
        i_number:=GetField(A_LoopField,#iconListViewNumber,characterSeparator)
        s_title:=GetField(A_LoopField,#stepTitle,characterSeparator)
     	 	LV_Add("Icon" . i_number ,s_title)
			 }
   }
   GuiControl, +ReDraw, MyListView
   LV_ModifyCol()

	if LV_GetCount()=1
	  cmdNone:=GetField( commandList , 28 ,characterSeparator)
	use_Toggle:= (cmdNone=0 || LV_GetCount()>1 ) ? 0 : 1
  ;MsgBox, % "use_Toggle= " . use_Toggle . "`ncmd= " . cmdNone . "`nCount:" . LV_GetCount()
	GuiControl, Show%use_Toggle%, ToggleWindow
	ampl_ReturnWindow:=1
Return
SaveScript:
  GuiControlGet, scriptName, , scriptName
  saveScript=%scriptName%
	if(SubStr(scriptName, -3, 4)<>".ahk"){
	  iniName := scriptName . ".ini"
	  scriptName := scriptName . ".ahk"
	  } else {
			StringTrimRight, iniName, scriptName, 4
			iniName := iniName . ".ini"
		}
	if key_Alt=D
	{
		InputBox, saveNewScript , %thisScript_Name% , Enter the New Name to save this script as:, , , 125, , , , ,
		if ERRORLEVEL=1
		  return
    IfExist, %ampldirectory%\scripts\%scriptName%
      FileDelete, %ampldirectory%\scripts\%scriptName%
		scriptName:=saveNewScript
		SaveScript:=saveNewScript
    GuiControl, , scriptName , %scriptName%
		if(SubStr(scriptName, -3, 4)<>".ahk"){
		  iniName := scriptName . ".ini"
		  scriptName := scriptName . ".ahk"
		  } else {
				StringTrimRight, iniName, scriptName, 4
				iniName := iniName . ".ini"
			}
	}
  GuiControl, , MessageFrame, Saving %saveScript%...
  GuiControl,,ProgressBar,0
  GuiControl, Show, ProgressBar

  if(ampldirectory=""){
    FileSelectFolder, ampldirectory, , 3, Select a Save Location
	}

	; Forget it if we don't have a directory to work with
	if (ampldirectory=""){
    MsgBox, 4, Oh Well, Forget it then, 20
	  GuiControl, , MessageFrame, Save aborted
	  GuiControl, Hide, ProgressBar
	  Return
	}

	scriptPath = %ampldirectory%\scripts\%scriptName%
	iniPath = %ampldirectory%\scripts\%iniName%
	includePath = %ampldirectory%\scripts\includes\AMPL_Includes.ahk

  ;msgbox, Generate %scriptName% in or around %directoryAMPL%`nScript Path: %scriptPath%`nInclude Path: %includePath%
  if(FileExist(scriptPath)<>"") {
    MsgBox, 4, thisScript_Name , %scriptName% Exists! Did you want to overwrite it?
    IfMsgBox, Yes
		{
      FileDelete, %scriptPath%
      IfExist, %iniPath%
        FileDelete, %iniPath%
			scriptHasBeenWritten:=1
		}
		else
		{
		  GuiControl, , MessageFrame, Save aborted
		  GuiControl, Hide, ProgressBar
		  Return
		}
	}

WriteFiles(scriptPath , iniPath , includePath, False )
GuiControl, , MessageFrame, %saveScript% generated!
scriptHasChanged:=0
;GuiControl, Hide, ProgressBar
Return

/*
** ********************************************************************************
** Main Window - Advanced :: Buttons
** ********************************************************************************
*/
ShowInfo_Simple:
ShowInfo:
GetKeyState, key_Shift, Shift
if(key_Shift = "D" )
  Gosub, goSettings
else
{
  SetTimer, WatchCursorMain , Off

	Gui, 3:+owner1  ; Make the main window (Gui #1) the owner of the "about box" (Gui #2).
	Gui +Disabled  ; Disable main window.
	if (windowInfoCreated=0)
	{
		gui, 3:font,Bold s14
		Gui, 3:Add, Picture, x3 y3 w72 h72 , %amplIcon%
		Gui, 3:Add, Text, x80 y30, %thisScript_Name%
		gui, 3:Font,Normal s8
		;gui, 3:Add, Text,, v %thisScript_Version% (%thisScript_VersionDate%)
		gui, 3:Add, Text,x10 y95 w250 ,An AutoHotKey script editor that is used in AMPL: A FARR Plugin to help create, manage and run simple AutoHotKey scripts.
		gui, 3:Add, Text,,%amplAuthor%
		;AddGraphicButton("GoWebSite", amplDirectory . "\scripteditor\icons\WebSite.ico", "x230 y65 w38 h38 ggoWebSite" , 32 , 32,3)
		gui, 3:font,Bold
		Gui, 3:Add, Button, x260 y33 w100 h20 ggoSettings, &Settings
		gui, 3:Font,Normal
		Gui, 3:Add, Button, x260 y95 w100 h20 ggoWebSite, &WebSite
		Gui, 3:Add, Button, x260 y120 w100 h20 ggoHelp, &Documentation
		;AddGraphicButton("GoHelp", amplDirectory . "\scripteditor\icons\HelpDocument.ico", "x230 y105 w38 h38 ggoHelp" , 32 , 32,3)
		Gui, 3:Add, Button, x260 y145 w100 h20 Default gShowInfoOK, &OK
		gui, 3:Add, ListView, x10 y145 w250,Name|Version
		gui,3: Default
    LV_Add("", "AMPL Package", version_AMPL_Package)
    LV_Add("", "AMPL Script Includes", version_AMPL_Includes_Installed)
    LV_Add("", "ScriptEditor", version_ScriptEditor)
    LV_Add("", "Editor Includes", version_ScriptEditorFunctions)
    LV_Add("", "Recorder", version_Recorder)
    LV_Add("", "ScriptUpdater", version_ScriptUpdate)
    LV_Add("", "ScriptShortCutter", version_ScriptShortCutter)
    LV_ModifyCol()
		;AddGraphicButton("GoOK", amplDirectory . "\scripteditor\icons\OK.ico", "x230 y145 w38 h38 gShowInfoOK" , 32 , 32,3)
		windowInfoCreated=1
	}
	WinGetPos, amplX, amplY, amplW, amplH, ahk_id %ampl_MainWindow%
	; adjust a wee bit so it looks ok
	amplX+=5
	amplY+=30

	Gui, 3: Show, x%amplX% y%amplY% , %thisScript_Name% :: About

	;Gui, 3:Show,,%thisScript_Name% :: About
}
Return
RunScript:
  runScript:=GetKeyState("Control")

	if !RunScript
	{
	  GuiControlGet, scriptName, , scriptName
	  saveScript=%scriptName%

		if(SubStr(scriptName, -3, 4)<>".ahk"){
		  iniName := scriptName . ".ini"
		  logName := scriptName . ".log"
		  scriptName := scriptName . ".ahk"
		  } else {
				StringTrimRight, iniName, scriptName, 4
			  logName := iniName . ".log"
				iniName := iniName . ".ini"
			}
		testScriptPath = %A_Temp%\%scriptName%
		testIniPath = %A_Temp%\%iniName%
		testLogPath = %A_Temp%\%logName%
		includePath = %ampldirectory%\scripts\includes\AMPL_Includes.ahk
	  IfExist, %testIniPath%
	    FileDelete, %testIniPath%
	  IfExist, %testScriptPath%
	    FileDelete, %testScriptPath%
		pathScriptLog = %OutDir%\%OutNameNoExt%.log
		IfExist, %testLogPath%
		  FileDelete, %testLogPath%

	  WriteFiles(testScriptPath , testIniPath , includePath, True )
	  d="
	  ahkPath= %d%%A_AhkPath%%d%
	  scriptTempPath = %d%%testScriptPath%%d%
		pathScriptLog=%d%%pathScriptLog%%d%

	  RunWait, %ahkPath% %scriptTempPath%,,UseErrorLevel,NewPID
	  If ERRORLEVEL=Error
	    MsgBox, There was an error running %scriptTempPath%

		MsgBox, 1, %thisScript_Name%, Do you want to view the log file?,
		IfMsgBox, OK
			Run, %scriptEditor% %testLogPath%, , UseErrorLevel,
	} else {
		if !scriptHasBeenWritten
      MsgBox, Script has not been Generated!
		else {
			if scriptHasChanged
			{
	      MsgBox, 4, %scriptName%, Script has changed! Did you want to generate it first?,
	      IfMsgBox, Yes
	          Gosub, SaveScript
	    }
        IfExist, %scriptPath%
        {
    	  d="
			  ahkPath= %d%%A_AhkPath%%d%
			  scriptTempPath = %d%%ScriptPath%%d%
				;pathScriptLog=%d%%pathScriptLog%%d%

			  Run, %ahkPath% %scriptTempPath%,,UseErrorLevel,NewPID
			  If ERRORLEVEL=Error
			    MsgBox, There was an error running %scriptTempPath%
			  } else {
          MsgBox, Can't find [%scriptPath%]
				}
		}
	}
Return
AddNewStep:
/*
  WinGetActiveTitle, aw
  if aw != %thisScript_Name% %thisScript_Version%
    return
*/
  GetKeyState, key_Shift, Shift
	; Title;PreDelay;Cmd;PostDelay;MoveX;MoveY;PostProcess
	commandObject := "New Step " (LV_GetCount() + 1)       ; Title
		. characterSeparator . def_cmdProcess                ; fileName
		. characterSeparator . def_delayBefore               ; delayBefore
		. characterSeparator . def_cmdPath                   ; cmdPath
		. characterSeparator . def_cmdParameter              ; cmdParameters
		. characterSeparator . def_cmdRunWait                ; cmdParameters
		. characterSeparator . def_cmdProcess                ; procedureName
		. characterSeparator . def_delayAfter                ; delayAfter
		. characterSeparator . def_MoveDo                    ; doMove
		. characterSeparator . def_MoveX                     ; moveX
		. characterSeparator . def_MoveY                     ; moveY
		. characterSeparator . def_SizeDo                    ; doSize
		. characterSeparator . def_SizeW                     ; sizeW
		. characterSeparator . def_SizeH                     ; sizeH
		. characterSeparator . def_minmaxAfter               ; minmaxAfter
		. characterSeparator . def_waitFor                   ; waitFor
		. characterSeparator . def_waitForTimeOut            ; waitForTimeOut
		. characterSeparator . def_actionWhen                ; actionWhen
		. characterSeparator . def_actionWhat                ; actionWhat
		. characterSeparator . def_actionForce               ; actionForce
		. characterSeparator . def_actionTimeOut             ; actionForce
		. characterSeparator . def_codeBefore                ; codeBefore
		. characterSeparator . def_codeAfter                 ; codeAfter
		. characterSeparator . def_winTitle                  ; windowTitle
		. characterSeparator . def_winClass                  ; windowClass
		. characterSeparator . def_iconListViewNumber        ; iconNumber
		. characterSeparator . def_iconPath                 ; iconLarge
		. characterSeparator . def_cmdNone                 	;
		. characterSeparator . def_msgShow
		. characterSeparator . def_msgTimeOut

	commandList = %commandList%%commandObject%`n
	scriptHasChanged+=1

  Gosub, DrawMainWindow
/*	GUICONTROL, -ReDraw, MyListView
	StringSplit, commandArray, commandObject, %characterSeparator%,
	LV_Add("", commandArray1)
	GuiControl, +ReDraw, MyListView
	LV_ModifyCol()

	if LV_GetCount()=1
	  cmdNone:=GetField( commandList , 28 ,characterSeparator)
	use_Toggle:= (cmdNone=0 || LV_GetCount()>1 ) ? 0 : 1
	GuiControl, Show%use_Toggle%, ToggleWindow
*/
  if(key_Shift = "D" ){
		Return
  }
    CommandBeingEdited := LV_GetCount()
    LV_GetText(rowText, CommandBeingEdited)

    StringSplit, commandListArray, commandList, `n,
    commandObject:=commandListArray%CommandBeingEdited%

    EditCommand( commandObject , CommandBeingEdited )

Return

DeleteStep:
	Gosub, GetSelectedRows
	StringTrimRight, commandList, commandList, 1
	StringSplit, commandListArray, commandList, `n,
	newCommandList=
	rowsToBeDeleted=
	StringReplace, RowList, RowList, `n, |, All
  Loop, %commandListArray0%
  {
    foundPos:=InStr(RowList, A_INDEX . "|", false, 1)
    ;if InStr(RowList, A_INDEX . "|", false, 1)>0
    if foundPos>0
    {
      if(doCut=false)
      {
		  	LV_GetText(stepName, A_INDEX, 1)
		  	MsgBox, 4, %thisScript_Name%, Delete %stepName%?
		  	IfMsgBox, Yes
		  	  doDelete:=true
				else
				  doDelete:=false
			} else
			{
			  doDelete:=true
			}
		  if (doDelete=true)
		  {
		    ;rowsToBeDeleted=%rowsToBeDeleted%%A_INDEX%`n
			} else
			{
			  thisObj:=commandListArray%A_INDEX%
		    newCommandList = %newCommandList%%thisObj%`n
    	}
		}
		else
		{
		  thisObj:=commandListArray%A_INDEX%
	    newCommandList = %newCommandList%%thisObj%`n
		}
	}
	commandList = %newCommandList%
  StringTrimRight, rowsToBeDeleted, rowsToBeDeleted, 1
  /*
  Sort, rowsToBeDeleted, N D`n R Z
  Loop , Parse, rowsToBeDeleted, `n
	{
	  if(LV_Delete(A_LoopField)=0) {
      MsgBox, Can't delete %A_LoopField%
      } else {
				scriptHasChanged+=1
			}
	}
	if LV_GetCount()=1
	  cmdNone:=GetField( commandList , 28 ,characterSeparator)
	use_Toggle:= (cmdNone=0 || LV_GetCount()>1 ) ? 0 : 1
	GuiControl, Show%use_Toggle%, ToggleWindow
	*/
  Gosub, DrawMainWindow
Return

EditStep:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
RowNumber := LV_GetNext(RowNumber,"Focused")  ; Resume the search at the row after that found by the previous iteration.

if RowNumber!=0
{
	CommandBeingEdited:=RowNumber
  LV_GetText(rowText, RowNumber)

  StringSplit, commandListArray, commandList, `n,
  commandObject:=commandListArray%RowNumber%
  ;MsgBox, %commandObject%
  changesMade=0
  SetTimer, WatchCursorMain , Off
  EditCommand( commandObject , CommandBeingEdited )
}
Return

DemoteStep:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
Gosub, GetSelectedRows
Sort, RowList, N D`n R Z
newRowList=
Loop , Parse, RowList, `n
{
	RowNumber=%A_LoopField%
	if RowNumber!=0
	{
		TotalRows := LV_GetCount()
		if (RowNumber < LV_GetCount())
		{
		  ;LV_GetText(rowText, RowNumber)
		  ;LV_Delete(RowNumber)
			NewRowNumber:=RowNumber+1
	    StringTrimRight, commandList, commandList, 1
	  	StringSplit, commandListArray, commandList, `n,
	  	newCommandList=
	    Loop, %commandListArray0%
	    {
	    	If A_INDEX = %NewRowNumber%
	    	{
			    thisObj:=commandListArray%RowNumber%
					i_number:=GetField(thisObj,#iconListViewNumber,characterSeparator)
					if i_number=
						i_number=0
				}
				else if A_INDEX = %RowNumber%
				{
			    thisObj:=commandListArray%NewRowNumber%
			    newRowList.= NewRowNumber . "`n"
				}
				else
				{
			    thisObj:=commandListArray%A_INDEX%
				}
	    	newCommandList = %newCommandList%%thisObj%`n
			}
			commandList = %newCommandList%
			scriptHasChanged+=1
	 	} else
	 	{
	    MsgBox, Row %RowNumber% is already at the bottom of the list!
		}
	} else
	{
	  break
	}
}
Gosub, DrawMainWindow
StringTrimRight, newRowList, newRowList, 1
Loop , Parse, newRowList, `n
{
	LV_Modify( A_LoopField,"Select")
}
Return

PromoteStep:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
Loop ;, Parse, RowList, `n
{
	RowNumber := LV_GetNext(RowNumber)  ; Resume the search at the row after that found by the previous iteration.
	if RowNumber!=0
	{
		if RowNumber>1
		{
		  ;LV_GetText(rowText, RowNumber)
  	  ;LV_Delete(RowNumber)
			NewRowNumber:=RowNumber-1
	    StringTrimRight, commandList, commandList, 1
	  	StringSplit, commandListArray, commandList, `n,
	  	newCommandList=
	    Loop, %commandListArray0%
	    {
	    	If A_INDEX = %NewRowNumber%
	    	{
			    thisObj:=commandListArray%RowNumber%
					i_number:=GetField(thisObj,#iconListViewNumber,characterSeparator)
				}
				else if A_INDEX = %RowNumber%
				{
			    thisObj:=commandListArray%NewRowNumber%
				}
				else
				{
			    thisObj:=commandListArray%A_INDEX%
				}
	    	newCommandList = %newCommandList%%thisObj%`n
	    }
		commandList = %newCommandList%
	  ;LV_Insert(NewRowNumber,"Icon" . i_number . " Focus Select", rowText)
		scriptHasChanged+=1
    Gosub, DrawMainWindow
    LV_Modify(NewRowNumber,"Select")
		} else
		{
	    MsgBox, Row %RowNumber% is already at the top of the list!
		}
	} else
	{
	  break
	}
}
Return

CopyStep:
GetKeyState, key_Shift, Shift
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
copyStepText=
StringSplit, commandListArray,commandList,`n,
Loop ;, Parse, RowList, `n
{
	RowNumber := LV_GetNext(RowNumber)  ; Resume the search at the row after that found by the previous iteration.
	if RowNumber!=0
	{
		StepText := commandListArray%RowNumber%
		copyStepText=%copyStepText%%StepText%`n
	} else
	{
		break
	}
}
StringTrimRight, copyStepText, copyStepText, 1
Clipboard = %copyStepText%
if(key_Shift = "D" )
	{
	  doCut:=true
  	Gosub, DeleteStep
  	doCut:=false
	}
Return

PasteStep:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
RowNumber := LV_GetNext(RowNumber)  ; Resume the search at the row after that found by the previous iteration.
insertRow=0
steps_ToBePasted= %Clipboard%
if RowNumber!=0
{
	addrows=
	insertRow:=RowNumber

	StringSplit, steps_Existing, commandList, `n,
	steps_Combined=
	listRow=0
  Loop, %steps_Existing0%
  {
    thisObj:=steps_Existing%A_INDEX%
    if(A_INDEX!=insertRow)
    {
      steps_Combined=%steps_Combined%%thisObj%`n
      listRow+=1
		} else
		{
      ;thisObj:=steps_Existing%A_INDEX%
      Loop, Parse, steps_ToBePasted, `n
      {
         pathCommand:=GetField(A_LoopField,#cmdPath,characterSeparator)
			   nameStep:=GetField(A_LoopField,#stepTitle,characterSeparator)
				 iconListViewNumber:=LoadIcon(pathCommand)
				 iconPath=%ERRORLEVEL%
				 stepToAdd:=UpDateField(A_LoopField , #iconListViewNumber , iconListViewNumber, characterSeparator)
				 stepToAdd:=UpDateField(stepToAdd , #iconPath , iconPath, characterSeparator)
         steps_Combined=%steps_Combined%%stepToAdd%`n
         /*
         listRow+=1
         LV_Insert(listRow, "Icon" . iconListViewNumber, nameStep)
         */
	 			 scriptHasChanged+=1
      }
			steps_Combined=%steps_Combined%%thisObj%`n
		}
	}
	commandList=%steps_Combined%
} else
{
  Loop, Parse, steps_ToBePasted, `n
  {
		 listRow:=LV_GetCount()
     pathCommand:=GetField(A_LoopField,#cmdPath,characterSeparator)
     nameStep:=GetField(A_LoopField,#stepTitle,characterSeparator)
		 iconListViewNumber:=LoadIcon(pathCommand)
		 iconPath=%ERRORLEVEL%
		 stepToAdd:=UpDateField(A_LoopField , #iconListViewNumber , iconListViewNumber, characterSeparator)
		 stepToAdd:=UpDateField(stepToAdd , #iconPath , iconPath, characterSeparator)
     CommandList=%CommandList%%stepToAdd%`n
     /*
     listRow+=1
     LV_Insert(listRow, "Icon" . iconListViewNumber, nameStep)
     */
		 scriptHasChanged+=1
  }
  ;commandList=%steps_Combined%
}

Gosub, DrawMainWindow
Return
MyListView:
if A_GuiEvent = doubleclick
{
	CommandBeingEdited:=A_EventInfo
  LV_GetText(rowText, A_EventInfo)
  ;MsgBox, You double-clicked on row number %A_EventInfo%: "%rowText%"

  StringSplit, commandListArray, commandList, `n,
  commandObject:=commandListArray%A_EventInfo%
  ;MsgBox, %commandObject%
  changesMade=0
  EditCommand( commandObject , CommandBeingEdited )

}
return

Generate:
  GetKeyState, key_Shift, Shift
  GetKeyState, key_Alt, Alt
  if(key_Shift = "D" ){
		; Shift down; prompt to load file

		; Check for changed file here
		SaveHere=SaveScript
    Gosub, checkSave

    scriptPath:=GetAMPLScript()
    IfExist, %scriptPath%
      {
       SplitPath, scriptPath, OutFileName, OutDir, OutExtension, scriptName, OutDrive
       GuiControl, , scriptName, %scriptName%
       GuiControl, -ReDraw, MyListView
			 ; Remove existing data
       commandList=
       success:=IL_Destroy(ImageListID)
			 ImageListID:=IL_Create(10,10, useLargeIcons)
			 success:=LV_SetImageList(ImageListID,1)
			 success:=IL_Add(ImageListID, startIcon)
			 ;LoadFile( scriptPath )
			 script_loadedSteps:=LoadFile( scriptPath )
			 script_cmd:=ERRORLEVEL
       Gosub, DrawMainWindow
			 ; Need to add scripl name
       GuiControl, +ReDraw, MyListView
       LV_ModifyCol()
       scriptHasChanged:=0
       scriptHasBeenWritten:=1
			}
  } else {
  ; No Shift; Generate
  Gosub, SaveScript
}
Return

WatchCursorMain:
  MouseGetPos, , , winID, controlID, 1     ; Find WindowID and controlID under mouse
  ;msgbox, ThisWin: %winID%`nampl: %ampl_MainWindow%
  if winID=%ampl_MainWindow%               ; If we're over the AMPL Main window
  {
    if controlID=Button1
    	GuiControl,,MessageFrame, Toggle ScriptEditor Window: Simple
    if controlID=Button2
    	GuiControl,,MessageFrame, About; +SHIFT: Settings
    if controlID=Button3
    	GuiControl,,MessageFrame, Test Scipt; +CNTL: Run real script
    if controlID=Button4
    	GuiControl,,MessageFrame, Add Step + Edit; +SHIFT: Add
    if controlID=Button5
    	GuiControl,,MessageFrame, Edit Step
    if controlID=Button6
    	GuiControl,,MessageFrame, Delete Step(s)
    if controlID=Button7
    	GuiControl,,MessageFrame, Demote Step(s)
    if controlID=Button8
    	GuiControl,,MessageFrame, Promote Step(s)
    if controlID=Button9
    	GuiControl,,MessageFrame, Copy Step(s); +SHIFT: Cut Steps(s)
    if controlID=Button10
    	GuiControl,,MessageFrame, Paste Step(s)
    if controlID=Button11
    	GuiControl,,MessageFrame, Save Script; +Alt: Save As; +SHIFT: Load Script
  }
Return

GetSelectedRows:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
RowList=
Loop
{
	RowNumber := LV_GetNext(RowNumber)  ; Resume the search at the row after that found by the previous iteration.
	if RowNumber!=0
	  RowList=%RowList%%RowNumber%`n
	else
	  break
}
Return

/*
** ********************************************************************************
** Main Window - Simple Routines
** ********************************************************************************
*/
createSimpleWindow:
	Gui, 4: +Resize +MinSize
	Gui, 4: Font, S12 CDefault Bold, Verdana
	Gui, 4: Add, Text, x64 y20 w h, %thisScript_Name%
	Gui, 4: Font, NORM s8,
	Gui, 4: Add, Picture, x3 y3 w48 h48, %amplIcon%
	Gui, 4: Font, S8 CDefault, Verdana
	Gui, 4: Add, Text, x6 y60 w30 h20 , Title:
	Gui, 4: Add, Edit, x40 y56 w456 h20 vscriptName_Simple , %scriptName%
	AddGraphicButton("ShowInfo_Simple", amplDirectory . "\scripteditor\icons\info.ico", "x502 y3 w38 h38 gShowInfo_Simple" , 32 , 32 , 4)
	AddGraphicButton("RunScript_Simple", amplDirectory . "\scripteditor\icons\run.ico", "x502 y47 w38 h38 gRunScript" , 32 , 32, 4)
	AddGraphicButton("ToggleWindow_Simple", amplDirectory . "\scripteditor\icons\togglewindow.ico", "x502 y89 w38 h38 gToggleWindow" , 32 , 32, 4)
	AddGraphicButton("GenerateScript_Simple", amplDirectory . "\scripteditor\icons\save.ico", "x502 y137 w38 h38 gGenerate_Simple" , 32 , 32, 4)
	Gui, 4: Add, Edit, x12 y80 w485 h295 vcodeAfter_Simple ,

	gui, 4: add, Text, x6 y377 w485 h20 vMessageFrame_Simple, Hello there...
	gui, 4: add, progress, x6 y396 h10 w485 vProgressBar_Simple
	; Hidden
	Gui, 4: Add, Edit, x100 y380 w100 h20 viconListViewNumber_Simple +ReadOnly, %commandObjectArray26%
	Gui, 4: Add, Edit, x100 y380 w100 h20 viconPath_Simple +ReadOnly, %commandObjectArray27%
  GuiControl, 4: Hide, iconListViewNumber_Simple
  GuiControl, 4: Hide, iconPath_Simple
	Gui, 4: Show, x160 y122 h410 w550, %thisScript_Name% %thisScript_Version%
	; Get the main window's Process ID for later use
	WinGet, ampl_SimpleWindow, ID, %thisScript_Name% %thisScript_Version%
	ampl_ReturnWindow:=4
Return
Generate_Simple:
  GetKeyState, key_Shift, Shift
  GetKeyState, key_Alt, Alt
  if(key_Shift = "D" ){
		; Shift down; prompt to load file

		; Check for changed file here
		SaveHere=SaveScript_Simple
    Gosub, checkSave

    scriptPath:=GetAMPLScript()
    IfExist, %scriptPath%
      {
       SplitPath, scriptPath, OutFileName, OutDir, OutExtension, scriptName, OutDrive
			 ; Remove existing data
       commandList=
       success:=IL_Destroy(ImageListID)
			 ImageListID:=IL_Create(10,10, useLargeIcons)
			 success:=LV_SetImageList(ImageListID,1)
			 success:=IL_Add(ImageListID, startIcon)
       Gosub, createMainWindow
			 windowMainCreated=1
			 script_loadedSteps:=LoadFile( scriptPath )
			 script_cmd:=ERRORLEVEL
			 
       LV_Delete()
       Loop, Parse, commandList,`n
       {
        if StrLen(A_LoopField)>0
           {
						i_number:=GetField(A_LoopField , #iconListViewNumber, characterSeparator)
						s_title:=GetField(A_LoopField, #stepTitle, characterSeparator)
         	 	success:=LV_Add("Icon" . i_number ,s_title)
					 }
       }

			if (script_loadedSteps=1 && script_cmd="NoCmd") {
				useEditor:=ampl_Editor_SIMPLE
				}
			else {
			  useEditor:=ampl_Editor_ADVANCED
			  }
			  
 			ampl_CurrentWindow:=ampl_Editor_SIMPLE

			if script_loadedSteps>0
			{
				if (useEditor=ampl_Editor_ADVANCED)
				{
			  	WinGetPos , X, Y, , , ahk_id %ampl_SimpleWindow%
					gui, 4: submit
					if windowMainCreated=0
						gosub, createMainWindow
					gui,1: Default
				  GuiControl, , scriptName, %scriptName%
				  Gosub, ShowMainWindow
					GUI, Show, x%x% y%y%
				  Gosub, DrawMainWindow
					windowMainCreated=1
					ampl_CurrentWindow:=ampl_Editor_ADVANCED
					ampl_ReturnWindow:=1
					SetTimer, WatchCursorMain , 100
			  } else {
				  codeA:=GetField( commandList , #codeAfter ,characterSeparator)
				  StringReplace, codeA, codeA,|, `n, All
			    GuiControl,4: , codeAfter_Simple , %codeA%
	  			GuiControl,4: , scriptName_Simple, %scriptName%
				}
			}
	  }
	} else {
	gosub, SaveScript_Simple
	}
Return
4GuiSize:
v = RunScript_Simple,GenerateScript_Simple,ToggleWindow_Simple
Loop, Parse, v, `,
   Anchor(A_LoopField, "x", true)
v = scriptName_Simple
Loop, Parse, v, `,
   Anchor(A_LoopField, "w", true)
v = MessageFrame_Simple,ProgressBar_Simple
Loop, Parse, v, `,
   Anchor(A_LoopField, "yw", true)
Anchor("codeAfter_Simple" , "wh")

Return
SaveScript_Simple:
  GuiControlGet, scriptName, , scriptName_Simple
  saveScript=%scriptName%
	if(SubStr(scriptName, -3, 4)<>".ahk"){
	  iniName := scriptName . ".ini"
	  scriptName := scriptName . ".ahk"
	  } else {
			StringTrimRight, iniName, scriptName, 4
			iniName := iniName . ".ini"
		}
	; Replace Code After
	gui, 4: submit, NoHide
  StringReplace, codeAfter_Simple, codeAfter_Simple,`n, |, All
  commandList:=UpdateField(commandList,#codeAfter,codeAfter_Simple, characterSeparator)

	if key_Alt=D
	{
		InputBox, saveNewScript , %thisScript_Name% , Enter the New Name to save this script as:, , , 125, , , , ,
		if ERRORLEVEL=1
		  return
    IfExist, %ampldirectory%\scripts\%scriptName%
      FileDelete, %ampldirectory%\scripts\%scriptName%
		scriptName:=saveNewScript
		SaveScript:=saveNewScript
    GuiControl, , scriptName , %scriptName%
		if(SubStr(scriptName, -3, 4)<>".ahk"){
		  iniName := scriptName . ".ini"
		  scriptName := scriptName . ".ahk"
		  } else {
				StringTrimRight, iniName, scriptName, 4
				iniName := iniName . ".ini"
			}
	}
  GuiControl, , MessageFrame_Simple, Saving %saveScript%...
  GuiControl,,ProgressBar_Simple,0
  GuiControl, Show, ProgressBar_Simple

  if(ampldirectory=""){
    FileSelectFolder, ampldirectory, , 3, Select a Save Location
	}

	; Forget it if we don't have a directory to work with
	if (ampldirectory=""){
    MsgBox, 4, Oh Well, Forget it then, 20
	  GuiControl, , MessageFrame_Simple, Save aborted
	  GuiControl, Hide, ProgressBar_Simple
	  Return
	}

	scriptPath = %ampldirectory%\scripts\%scriptName%
	iniPath = %ampldirectory%\scripts\%iniName%
	includePath = %ampldirectory%\scripts\includes\AMPL_Includes.ahk

  ;msgbox, Generate %scriptName% in or around %directoryAMPL%`nScript Path: %scriptPath%`nInclude Path: %includePath%
  if(FileExist(scriptPath)<>"") {
    MsgBox, 4, thisScript_Name , %scriptName% Exists! Did you want to overwrite it?
    IfMsgBox, Yes
		{
      FileDelete, %scriptPath%
      IfExist, %iniPath%
        FileDelete, %iniPath%
			scriptHasBeenWritten:=1
		}
		else
		{
		  GuiControl, , MessageFrame_Simple, Save aborted
		  GuiControl, Hide, ProgressBar_Simple
		  Return
		}
	}

WriteFiles(scriptPath , iniPath , includePath, False )
GuiControl, , MessageFrame_Simple, %saveScript% generated!
scriptHasChanged:=0

Return
/*
** ********************************************************************************
** About Window Functions
** ********************************************************************************
*/
3guiclose:
ShowInfoOK:
	gui,3: Hide
	Gui,%ampl_ReturnWindow%: Default
	GUI, Show
	if ampl_ReturnWindow=1
		SetTimer, WatchCursorMain , 100
	gui, -Disabled
Return

goSettings:
Run, %A_ScriptDir%\Settings.ahk, , ,
Return
goWebSite:
Run, http:\\%amplWebSite%
Return
goHelp:
Run, %amplDirectory%\scripteditor\AMPLScriptEditor.chm
Return


/*
** ********************************************************************************
** Step Window Routines
** ********************************************************************************
*/
EditCommand(cmdObject , cmdIndex)
{
	Global characterSeparator, selectMonitor, WinStepTitle, ampl_MainWindow, amplDirectory,windowStepCreated,startIcon,gotWinDetails,listVariables, cmd_WorkingDirectory, listPlugins, listPreFix
	;Global characterSeparator, iconListViewNumber, startIcon, selectMonitor, WinStepTitle, ampl_MainWindow, amplDirectory,windowStepCreated
	; don't need cmdIcon as Global as it should be in the cmdObject
	WinStepTitle = AMPL :: Step %cmdIndex%
  ;listVariables = Wait Post Run|Wait Window PID|Wait Window Class|Wait Window Title|Set Window Title|Set Window Text|Set Window Exclude Title|Set Window Exclude Text|Include Wait Functions
	;GUI, 2: Destroy
	StringSplit, commandObjectArray, cmdObject, %characterSeparator%,
  GuiControl, Hide, ProgressBar
	GuiControl,,MessageFrame, Editing: %commandObjectArray1%

	;commandArray13:=RegExReplace(commandArray13, "|", "`n")
  StringReplace, commandObjectArray22, commandObjectArray22,|, `n, All
  StringReplace, commandObjectArray23, commandObjectArray23,|, `n, All

  Loop, Parse, commandObjectArray22, `n,
  {
  	if InStr(A_LoopField, "cmd_WorkingDirectory", false, 1)
  	  {
        StringSplit, lineArray, A_LoopField, =,
        cmdWorkingDirectory := lineArray2
        searchChar="
				replaceChar=
        StringReplace, cmdWorkingDirectory, cmdWorkingDirectory, %searchChar%, %replaceChar%, 1
			}
  }
  ;MsgBox, Working Directory: %cmdWorkingDirectory%
	if (windowStepCreated=0)
	{
		Gui, 2: +owner1  +Resize +MinSize
		gui +Disabled
		Gui, 2: Font, S8 CDefault Bold, Verdana
		Gui, 2: Add, Edit, x48 y7 w340 h20 vstepTitle  -TabStop, %commandObjectArray1%
		Gui, 2: Font, S8 CDefault Normal, Verdana
		; tab control
		Gui, 2: Add, Tab2, x4 y38 w440 h299 vStepTabs ,Simple|Advanced|Window
		; delayBefore
		Gui, 2: Add, Text, x12 y71 w80 h20 , Pause &Before
		Gui, 2: Add, Edit, x100 y67 w159 h20 +Number vdelayBefore gPreDelay, %commandObjectArray3% ; preDelay in milliseconds
		; cmdPath
		Gui, 2: Add, Text, x12 y98 w80 h20 , C&ommand
		Gui, 2: Add, Edit, x100 y94 w302 h20 vcmdPath +ReadOnly -TabStop, %commandObjectArray4%
		Gui, 2: Add, Button, x406 y93 w27 h20 vGetCmd gGetCommand, ...
		; cmdParameters
		Gui, 2: Add, Text, x12 y126 w80 h20 , &Parameter/s
		Gui, 2: Add, Edit, x100 y121 w302 h20 vcmdParameter  Disabled, %commandObjectArray5%
		Gui, 2: Add, Button, x406 y120 w27 h20 gGetFileParameter vGetFileParameter Disabled, ...
	  ; move
		Gui, 2: Add, Text, x12 y152 w90 h20 , Mo&ve Window
		Gui, 2: Add, CheckBox, x100 y152  vMoveDo gMoveDo Checked%commandObjectArray9%
		Gui, 2: Add, DropDownList, x149 y148 AltSubmit vusePosition gusePosition, Manual||Top Left|Top Middle|Top Right|Centre Left|Centre Middle|Centre Right|Bottom Left|Bottom Middle|Bottom Right
		Gui, 2: Add, DropDownList, x313 y148 AltSubmit vuseMonitor gCalculateXY, %selectMonitor%
		Gui, 2: Add, Text, x134 y180 +Right, &X:
		Gui, 2: Add, Edit, x149 y176 w70 h20 vMoveX  +Number, %commandObjectArray10%
		Gui, 2: Add, Text, x224 y180 +Right, &Y:
		Gui, 2: Add, Edit, x238 y176 w70 h20 vMoveY  +Number, %commandObjectArray11%
		; size
		Gui, 2: Add, Text, x12 y208 w90 h20 , Si&ze Window
		Gui, 2: Add, CheckBox, x100 y208 vSizeDo gSizeDo Checked%commandObjectArray12%
		Gui, 2: Add, Text, x134 y208 +Right, &W:
		Gui, 2: Add, Edit, x149 y204 w70 h20 vSizeW  +Number , %commandObjectArray13%
		Gui, 2: Add, Text, x224 y208 +Right, &H:
		Gui, 2: Add, Edit, x238 y204 w70 h20 vSizeH  +Number , %commandObjectArray14%
		; get details button
	  GUI, 2: Add, Button, x313 y176 w71 h48 gGrabDetails vGrabDetails, &Get`nWindow's`nDetails
		; minmaxAfter
		Gui, 2: Add, Text, x12 y232 w114 h20 , &Min / Max
		thisminmaxAfter := commandObjectArray15
		;MsgBox, %minmaxAfter%
		if (thisminmaxAfter = 1)
				Gui, 2: Add, Radio, x100 y232 w74 h18 vminmaxAfter1  Checked, None
		else
				Gui, 2: Add, Radio, x100 y232 w74 h18 vminmaxAfter1  , None

		if (thisminmaxAfter = 2)
				Gui, 2: Add, Radio, x175 y232 w82 h19 vminmaxAfter2  Checked, Minimise
		else
				Gui, 2: Add, Radio, x175 y232 w82 h19 vminmaxAfter2  , Minimise

		if (thisminmaxAfter = 3)
				Gui, 2: Add, Radio, x268 y232 w75 h17 vminmaxAfter3  Checked, Maximise
		else
				Gui, 2: Add, Radio, x268 y232 w75 h17 vminmaxAfter3  , Maximise

	  ; delayAfter
		Gui, 2: Add, Text, x12 y264 w80 h20 , Pause &After
		Gui, 2: Add, Edit, x100 y260 w159 h20 vdelayAfter , %commandObjectArray8%
		Gui, 2: Add, CheckBox, x100 y291 vmsgShow gmsgShowClick Checked%commandObjectArray29%
		Gui, 2: Add, Text, x12 y291 h20, &Show Msgs
		Gui, 2: Add, Text, x130 y291 h20, Time Out
		Gui, 2: Add, Edit, x210 y287 w50 h20 vmsgTimeOut , %commandObjectArray30%
	  ; Advanced
		Gui, 2: Tab, 2
		; Code Before
		Gui, 2: Add, Text, x12 y70 w400 h20 , Code to run Before Command
		Gui, 2: Font, S7 CDefault , Verdana
		gui, 2: Add, DropDownList, x200 y65 w150 AltSubmit vVariableToAdd gVariableToAdd, %listPlugins%
		Gui, 2: Font, S8 CDefault , Verdana
		gui, 2: Add, button, x352 y65 w25 h19 gAddV vAddV ,&a
    GuiControl, 2: Disable, AddV,
		gui, 2: Add, button, x380 y65 w55 h19 gEditCB vEditCB, edit
		Gui, 2: Add, Edit, x12 y86 w421 h76 vcodeBefore , %commandObjectArray22%
		; Run Wait
		Gui, 2: Add, Text, x12 y166 w200 h20 vrunWait_Label, Wait for Command to finish first?
		Gui, 2: Add, CheckBox, x215 y163 w20 h20 vcmdRunWait gUseNoCmd  Checked%commandObjectArray6%,
		gui, 2: Add, Text, x250 y166 w90 h20 vnoCmd_Label, No Command
		Gui, 2: Add, CheckBox, x350 y163 w20 h20 vCmdNone gUseNoCmd Checked%commandObjectArray28%,
		; Code After
		Gui, 2: Add, Text, x12 y187 w400 h20 vcodeAfter_Label, Code to run After Command
		gui, 2: Add, button, x310 y182 w60 h19 vRunCA gRunCA, test
		gui, 2: Add, button, x375 y182 w60 h19 vEditCA gEditCA, edit
		Gui, 2: Add, Edit, x12 y201 w421 h75 vcodeAfter , %commandObjectArray23%
	  ; waitFor
		gui, 2: Add, Text, x12 y286 vwaitFor_Label, Wait For
		gui, 2: Add, DropDownList, x65 y282 vwaitFor  AltSubmit Choose%commandObjectArray16%, Nothing|Window Inactive|Window Close
		gui, 2: Add, Text, x195 y286 h20 vwaitforTimeOut_Label, Time Out
		gui, 2: Add, Edit, x258 y282 w40 h20 vwaitForTimeOut , %commandObjectArray17%
	  ; shutdownAction
		gui, 2: Add, Text, x12 y309 vaction_Label, Action
		gui, 2: Add, DropDownList, x65 y306 vActionWhen  AltSubmit Choose%commandObjectArray18%, Always|After Success|After Error|After Failure
		;gui, 2: Add, Text, x223 y299 h20, Time Out:
		gui, 2: Add, DropDownList, x195 y306 vActionWhat gSetForce AltSubmit Choose%commandObjectArray19%, Nothing|Normalize Window|Minimize Window|Maximize Window|Close Window|Minimize All|Log Off|Shut Down|Reboot|Power Down
		gui, 2: Add, Text, x345 y309 vForceLabel, Force
		gui, 2: Add, CheckBox, x325 y307 w20 h20 vActionForce  Checked%commandObjectArray20%
		gui, 2: Add, Edit, x385 y306 h20 w40 vActionTimeOut , %commandObjectArray21%

		Gui, 2: Tab, 3
		Gui, 2: Font, S8 CDefault Bold, Verdana
		Gui, 2: Add, Text, x12 y75 w400 h20 , Script Window
		Gui, 2: Font, S8 CDefault Normal, Verdana
		Gui, 2: Add, Text, x12 y98 w70 h20 , Title
		Gui, 2: Add, Edit, x70 y94 w130 h20 vwinTitle +ReadOnly, %commandObjectArray24%
		Gui, 2: Add, Text, x12 y125 w70 h20 , Class
		Gui, 2: Add, Edit, x70 y121 w130 h20 vwinClass +ReadOnly, %commandObjectArray25%
		Gui, 2: Add, Text, x12 y152 w70 h20 , Cmd PID
		Gui, 2: Add, Edit, x70 y148 w130 h20 vrun_PID +ReadOnly,

		Gui, 2: Add, Text, x220 y98 w70 h20 vcmdProcess_Label, Process
		Gui, 2: Add, Edit, x290 y94 w130 h20 vcmdProcess +ReadOnly, %commandObjectArray7%
		Gui, 2: Add, Text, x220 y125 w70 h20 vfileName_Label, FileName
		Gui, 2: Add, Edit, x290 y121 w130 h20 vfileName +ReadOnly, %commandObjectArray2%
		Gui, 2: Add, Text, x220 y152 w70 h20 vwin_PID_Label, Win ID
		Gui, 2: Add, Edit, x290 y148 w130 h20 vwin_PID +ReadOnly,
		; Hidden
		Gui, 2: Add, Edit, x100 y380 w100 h20 viconListViewNumber +ReadOnly, %commandObjectArray26%
		Gui, 2: Add, Edit, x100 y380 w100 h20 viconPath +ReadOnly, %commandObjectArray27%
		gui, 2: Add, Edit, x100 y380 w100 h20 vcmdOriginal +ReadOnly, %cmdObject%

    GuiControl, 2: Hide, iconListViewNumber
    GuiControl, 2: Hide, iconPath
    GuiControl, 2: Hide, cmdOriginal
		Gui, 2: Font, S8 CDefault Bold, Verdana
		; Add 110
		Gui, 2: Add, Text, x12 y185 w400 h20 , Check Window
		Gui, 2: Font, S8 CDefault Normal, Verdana
		Gui, 2: Add, Text, x12 y208 w70 h20 , Title
		Gui, 2: Add, Edit, x70 y204 w130 h20 vxwinTitleCheck +ReadOnly,
		Gui, 2: Add, Text, x12 y235 w70 h20 , Class
		Gui, 2: Add, Edit, x70 y231 w130 h20 vxwinClassCheck +ReadOnly,
		Gui, 2: Add, Text, x12 y262 w70 h20 , Cmd PID
		Gui, 2: Add, Edit, x70 y258 w130 h20 vrun_PIDCheck +ReadOnly,

		Gui, 2: Add, Text, x220 y208 w70 h20 vcmdProcessCheck_Label, Process
		Gui, 2: Add, Edit, x290 y204 w130 h20 vcmdProcessCheck +ReadOnly,
		Gui, 2: Add, Text, x220 y235 w70 h20 vfileNameCheck_Label, FileName
		Gui, 2: Add, Edit, x290 y231 w130 h20 vfileNameCheck +ReadOnly,
		Gui, 2: Add, Text, x220 y262 w70 h20 vwin_PID_Check_Label, Win ID
		Gui, 2: Add, Edit, x290 y258 w130 h20 vwin_PIDCheck +ReadOnly,
		gui, 2: Add, Button, gCheckWindow vCheckWindow, Check Window
		Gui, 2: Tab

		; New side buttons
	  AddGraphicButton("ScriptWriter", amplDirectory . "\scripteditor\icons\Recorder.ico", "x448 y58 w38 h38 gRunScriptWriter" , 32 , 32,2)
	  AddGraphicButton("WindowsSpy", amplDirectory . "\scripteditor\icons\AU3_Spy.ico", "x448 y97 w38 h38 gRunWindowSpy" , 32 , 32,2)
	  AddGraphicButton("AHKHelp", amplDirectory . "\scripteditor\icons\Help.ico", "x448 y136 w38 h38 gRunHelp" , 32 , 32,2)
	  AddGraphicButton("TestStep", amplDirectory . "\scripteditor\icons\TestStep.ico", "x448 y181 w38 h38 gTestStep" , 32 , 32,2)
	  AddGraphicButton("ClearScript", amplDirectory . "\scripteditor\icons\RemoveStep.ico", "x448 y220 w38 h38 gClearScript" , 32 , 32,2)
	  AddGraphicButton("CancelScript", amplDirectory . "\scripteditor\icons\CancelStep.ico", "x448 y259 w38 h38 gCancelScript" , 32 , 32,2)
	  AddGraphicButton("SaveStep", amplDirectory . "\scripteditor\icons\SaveStep.ico", "x448 y298 w38 h38 gSaveStep" , 32 , 32,2)

	  ;AddGraphicButton("TestStep", amplDirectory . "\scripteditor\icons\movedown.ico", "x448 y213 w38 h38 gDoSomething" , 32 , 32,2)
		; Generated using SmartGUI Creator 4.0

		; Message Frame
		Gui, 2: Add, Edit, x4 y345 w481 h50 vMessageFrame ReadOnly,

	; Generated using SmartGUI Creator 4.0
		if StrLen(commandObjectArray4) = 0
			{
				GuiControl, 2: Disable, GrabDetails
				Gui, 2: Add, Picture, x6 y3 w32 h32 vLargeIcon, %startIcon%
			}
			else{
			  if StrLen(commandObjectArray26)>0  and FileExist(commandObjectArray27)
		    	Gui, 2: Add, Picture, x6 y3 w32 h32 vLargeIcon, %commandObjectArray27%
		    else
		      Gui, 2: Add, Picture, x6 y3 w32 h32 vLargeIcon, %startIcon%
		    GuiControl, 2: Enable, cmdParameter
		    GuiControl, 2: Enable, GetFileParameter
			  }
	  windowStepCreated=1
	} else
	{
    ;MsgBox, Window already created: %commandObjectArray1%
    gui +Disabled
    Gui 2:Default
    GuiControl, , stepTitle, %commandObjectArray1%
    GuiControl, , delayBefore, %commandObjectArray3%
    GuiControl, , cmdPath, %commandObjectArray4%
    GuiControl, , cmdParameter, %commandObjectArray5%
		GuiControl,,MoveDo,%commandObjectArray9%
		GuiControl,,usePosition,|Manual||Top Left|Top Middle|Top Right|Centre Left|Centre Middle|Centre Right|Bottom Left|Bottom Middle|Bottom Right
		GuiControl,,MoveX,%commandObjectArray10%
		GuiControl,,MoveY,%commandObjectArray11%
		GuiControl,,SizeDo,%commandObjectArray12%
		GuiControl,,SizeW,%commandObjectArray13%
		GuiControl,,SizeH, %commandObjectArray14%
		thisminmaxAfter := commandObjectArray15
		if (thisminmaxAfter = 1)
				GuiControl,,minmaxAfter1,1
		else
		    GuiControl,,minmaxAfter1,0

		if (thisminmaxAfter = 2)
				GuiControl,,minmaxAfter2,1
		else
				GuiControl,,minmaxAfter2,0

		if (thisminmaxAfter = 3)
				GuiControl,,minmaxAfter3,1
		else
				GuiControl,,minmaxAfter3,0

		GuiControl,,delayAfter, %commandObjectArray8%
		GuiControl,,msgShow, %commandObjectArray29%
		GuiControl,,msgTimeOut, %commandObjectArray30%
		GuiControl,,EditCB, edit
		GuiControl,,codeBefore,%commandObjectArray22%
		GuiControl,,cmdRunWait,%commandObjectArray6%
		GuiControl,,cmdNone,%commandObjectArray28%

		GuiControl,,EditCA, edit
		GuiControl,,codeAfter,%commandObjectArray23%
		GuiControl, Choose, waitFor,%commandObjectArray16%
		GuiControl,,waitForTimeOut,%commandObjectArray17%
		GuiControl, Choose, actionWhen,%commandObjectArray18%
		GuiControl, Choose, actionWhat,%commandObjectArray19%
		GuiControl,,actionForce,%commandObjectArray20%
		GuiControl,,actionTimeOut,%commandObjectArray21%

		GuiControl,,winTitle, %commandObjectArray24%
		GuiControl,,winClass,%commandObjectArray25%
		GuiControl,,cmdProcess,%commandObjectArray7%
		GuiControl,,fileName, %commandObjectArray2%
		GuiControl,,iconListViewNumber, %commandObjectArray26%
		GuiControl,,iconPath, %commandObjectArray27%
		GuiControl,,cmdOriginal, %cmdObject%
		GuiControl,,xwinClassCheck,
		GuiControl,,xwinTitleCheck,
		GuiControl,,cmdProcessCheck,
		GuiControl,,win_PIDCheck,
		GuiControl,,run_PIDCheck,

		if StrLen(commandObjectArray4) = 0
			{
				GuiControl, 2: Disable, GrabDetails
		    GuiControl, 2: Disable, cmdParameter
				GuiControl, ,LargeIcon,*x6 *y3 *w32 *h32 %startIcon%
				;msgbox #4: %commandObjectArray4%`nStartIcon: %startIcon%
			}
			else{
			  if StrLen(commandObjectArray26)>0 and FileExist(commandObjectArray27)
			  {
			    ;msgbox #26: %commandObjectArray26%`n#27: %commandObjectArray27%
		    	GuiControl,,LargeIcon,*x6 *y3 *w32 *h32 %commandObjectArray27%
		    	}
		    else
		      {
					;msgbox #26: %commandObjectArray26%`n#27: %commandObjectArray27%`nStartIcon: %startIcon%
					GuiControl,,LargeIcon,*x6 *y3 *w32 *h32 %startIcon%
					}
		    GuiControl, 2: Enable, cmdParameter
		    GuiControl, 2: Enable, GetFileParameter
			  }
	}
; Get the main window's position
WinGetPos, amplX, amplY, amplW, amplH, ahk_id %ampl_MainWindow%
; adjust a wee bit so it looks ok
amplX+=5
amplY+=30

Gui, 2: Show, x%amplX% y%amplY% h399 w489, %WinStepTitle%
Gui +LastFound
GoSub, MoveDo
GoSub, usePosition
GoSub, SizeDo
Gosub, msgShowClick
Gosub, SetForce
;Gosub, VariableToAdd
if(commandObjectArray24="" and commandObjectArray25="" and commandObjectArray7="") {
	gotWinDetails=0
} else {
	gotWinDetails=1
}

GUICONTROL,Focus, delayAfter

SetTimer, WatchCursor , 100
gosub, UseNoCmd

}
2GuiSize:
v=VariableToAdd,stepTitle,cmdPath,cmdParameter
Loop, Parse, v, `,
	Anchor(A_LoopField, "w", true)
Anchor("codeBefore","h0.5w")
Anchor("codeAfter","y0.5h0.5w")
Anchor("StepTabs","hw")
Anchor("MessageFrame","wy")
v = ScriptWriter,WindowsSpy,AHKHelp,TestStep,ClearScript,CancelScript,SaveStep,AddV,EditCB,GetCmd,GetFileParameter
Loop, Parse, v, `,
   Anchor(A_LoopField, "x", true)
v = runWait_Label,cmdRunWait,noCmd_Label,CmdNone,codeAfter_Label
Loop, Parse, v, `,
   Anchor(A_LoopField, "y0.5", true)
v = RunCA,EditCA
Loop, Parse, v, `,
   Anchor(A_LoopField, "y0.5x", true)
v = waitFor_Label,waitFor,waitForTimeOut,waitForTimeOut_Label,action_Label,actionWhen,actionWhat,actionForce,ForceLabel,actionTimeOut
Loop, Parse, v, `,
   Anchor(A_LoopField, "y", true)
v = cmdProcess_Label,fileName_Label,win_PID_Label,win_PID_Check_Label,fileNameCheck_Label,cmdProcessCheck_Label,CheckWindow
Loop, Parse, v, `,
   Anchor(A_LoopField, "x0.5", true)
v = cmdProcess,fileName,win_PID,cmdProcessCheck,fileNameCheck,win_PIDCheck
Loop, Parse, v, `,
   Anchor(A_LoopField, "x0.5w0.5", true)
v = winTitle,winClass,run_PID,xwinTitleCheck,xwinClassCheck,run_PIDCheck
Loop, Parse, v, `,
   Anchor(A_LoopField, "w0.5", true)
Return

; Get the command to run
GetCommand:
	GetKeyState, key_Shift, Shift
	if(key_Shift = "D" )
	{
	  FileSelectFolder, fileToRun, ::{20d04fe0-3aea-1069-a2d8-08002b30309d}, 3, Select a Folder
	} else
	{
	  fileToRun:=GetProgrammeFile()
	}
  if(fileToRun="") {
    ; Dialog was cancelled
    Return
	}
  SplitPath, fileToRun, fileName, filePath, fileExtension, ,
	; If the file is a link, then we'll load the link settings
  if fileExtension = lnk
  {
    FileGetShortcut, %fileToRun%, fileToRun, cmdWorkingDirectory, linkArgs, linkComments, linkIcon, linkIconNum, linkState
    GuiControl, , cmdParameter, %linkArgs%
    ; Need to do sonmething with linkState
		if (linkState = 1)
				GuiControl,,minmaxAfter1,1
		else
		    GuiControl,,minmaxAfter1,0

		if (linkState = 7)
				GuiControl,,minmaxAfter2,1
		else
				GuiControl,,minmaxAfter2,0

		if (linkState = 3)
				GuiControl,,minmaxAfter3,1
		else
				GuiControl,,minmaxAfter3,0

    GuiControlGet, thisCB, , codeBefore,
    cr=`n
		if linkComments!=
		  linkComments:=cr . "; Link Comment:" . linkComments
    GuiControl, , codeBefore, %thisCB%%linkComments%`ncmd_workingDirectory:="%cmdWorkingDirectory%"
	}
  GuiControl, , cmdPath, %fileToRun%
	GuiControl,,fileName,%fileName%

	iconListViewNumber:=LoadIcon(fileToRun)
	iconPath=%ERRORLEVEL%
	GuiControl,,iconPath,%iconPath%
	GuiControl,,iconListViewNumber,%iconListViewNumber%
	GuiControl,,LargeIcon,*x6 *y3 *w32 *h32 %iconPath%

  GuiControlGet, oldstepTitle, 2:, stepTitle
  ; Add Process Name if not changed
  if SubStr(oldstepTitle, 1, 8) = "New Step" || InStr(oldstepTitle, ".exe") > 0
     GuiControl, , stepTitle, %fileName%
  GuiControl, Enable, GrabDetails
  GuiControl, Enable, cmdParameter
  GuiControl, Enable, GetFileParameter

Return

GetFileParameter:
	GetKeyState, key_Shift, Shift
	if(key_Shift = "D" )
	{
		  FileSelectFolder, selectedFiles, ::{20d04fe0-3aea-1069-a2d8-08002b30309d}, 3, Select a Folder
	} else
	{
		selectedFiles:=GetAnyFiles()
	}
  if(selectedFiles="") {
    ; Dialog was cancelled
    Return
	}
	ic="
	fileParameter=
	; Handle Mulpiple files correctly
  Loop, Parse, selectedFiles ,|,
  {
		if InStr(A_LoopField, A_SPACE)>0
		  fileParameter .= ic . A_LoopField . ic . A_SPACE
		else
		  fileParameter .= A_LoopField . A_SPACE
  }
  
  StringTrimRight, fileParameter, fileParameter, 1  ; Remove the added space
  
	GuiControlGet, oldFileParameter,2: , cmdParameter

	if StrLen(oldFileParameter)>0
	{
	 MsgBox, 4, %thisScript_Name%, Replace or Add?`nYes for Replace, No for Add,
	 IfMsgBox, No
      oldFileParameter := oldFileParameter . A_SPACE . fileParameter
   else
       oldFileParameter := fileParameter
  } else {
    oldFileParameter := fileParameter
  }

  GuiControl, , cmdParameter, %oldFileParameter%

Return
CheckWindow:
	WinGet, this_Window, ID, A
  MsgBox , 4097 , %thisScript_Name% , Highlight the window to check and click OK
  IfMsgBox, OK
  {
	  WinGetActiveStats, check_winTitle, check_Width, check_Height, check_X, check_Y
	  WinGet, check_ID, ID, A
	  ;MsgBox, ampl_PID: %ampl_PID%
	  ;NewPID=%get_PID%
		if check_ID!=
		{
		  WinGet, check_cmdProcess, ProcessName, ahk_id %check_ID%
		  WinGet, check_PID, PID , ahk_id %check_ID%
		}else {
			WinGet, check_cmdProcess, ProcessName, A
			WinGet, check_PID, PID, A
		}
	  WinGetClass, check_winClass, ahk_id %check_ID%
		;MsgBox, Window: %Title%`nWidth: %Width%`nHeight: %Height%`nLocation-X: %X%`nLocation-Y: %Y%
	  ;MsgBox, Title: %winTitle%`nProcess: %cmdProcess%`nClass: %winClass%
		GuiControl,,xwinClassCheck, %check_winClass%
		GuiControl,,xwinTitleCheck, %check_winTitle%
		GuiControl,,cmdProcessCheck, %check_cmdProcess%
		GuiControl,,win_PIDCheck, %check_ID%
		GuiControl,,run_PIDCheck, %check_PID%
	}
	WinActivate, ahk_id %this_Window%
Return

TestStep:
	scriptTempPath=%A_Temp%\temp.ahk

  IfExist, %scriptTempPath%
    FileDelete, %scriptTempPath%

  FileAppend,
	(
	  version_AMPL_Includes_Used=%version_AMPL_Includes_Installed%
		#Include %amplDirectory%\scripts\includes\AMPL_Includes.ahk
		DoLogToFile:=true

	), %scriptTempPath%

	tmpminmaxAfter:=PP()

  GuiControlGet, tmpstepTitle, 2:, stepTitle
	GuiControlGet, tmpdelayBefore, 2:, delayBefore
	GuiControlGet, tmpcmdPath, 2:, cmdPath
	GuiControlGet, tmpcmdParameter, 2:, cmdParameter
	GuiControlGet, tmpdelayAfter, 2:, delayAfter
	GuiControlGet, tmpMoveDo, 2:, MoveDo
	GuiControlGet, tmpMoveX, 2:, MoveX
	GuiControlGet, tmpMoveY, 2:, MoveY
	GuiControlGet, tmpSizeDo, 2:, SizeDo
	GuiControlGet, tmpSizeW, 2:, SizeW
	GuiControlGet, tmpSizeH, 2:, SizeH
	;GuiControlGet, commandArray13, 2:, minmaxAfter
  GuiControlGet, tmpWaitFor, 2:, WaitFor
  GuiControlGet, tmpwaitForTimeOut, 2:, waitForTimeOut
	GuiControlGet, tmpcodeBefore, 2:, codeBefore
	GuiControlGet, tmpcodeAfter, 2:, codeAfter
	GuiControlGet, tmpActionWhen, 2:, ActionWhen
	GuiControlGet, tmpActionWhat, 2:, ActionWhat
	GuiControlGet, tmpActionForce, 2:, ActionForce
	GuiControlGet, tmpActionTimeOut, 2:, actionTimeOut
  GuiControlGet, tmpcmdRunWait, 2:, cmdRunWait
  GuiControlGet, tmpCmdNone, 2:, CmdNone
  GuiControlGet, tmpMsgShow, 2:, msgShow
  GuiControlGet, tmpmsgTimeOut, 2:, msgTimeOut
	GuiControlGet, tmpWinTitle, 2:, winTitle
	GuiControlGet, tmpWinClass, 2:, winClass
	GuiControlGet, tmpcmdProcess, 2:, cmdProcess

	commandArray4=

  	;StringReplace, commandArray13, commandArray13, "|", `n, All

    SplitPath, tmpcmdPath, , , , , fileDrive

    FileAppend,
    (
; Step Variables
step_title=%tmpstepTitle%
cmd_delayBefore=%tmpdelayBefore%
cmd_fullPath=%tmpcmdPath%
cmd_parameters=%tmpcmdParameter%
cmdNone=%tmpCmdNone%
cmd_delayAfter=%tmpdelayAfter%
win_moveDo=%tmpMoveDo%
win_moveX=%tmpMoveX%
win_moveY=%tmpMoveY%
win_sizeDo=%tmpSizeDo%
win_sizeW=%tmpSizeW%
win_sizeH=%tmpSizeH%
win_minMax=%tmpminmaxAfter%
step_waitFor=%tmpWaitFor%
step_waitForTimeOut=%tmpwaitForTimeOut%
step_actionWhen=%tmpActionWhen%
step_actionWhat=%tmpActionWhat%
step_actionForce=%tmpActionForce%
step_actionTimeOut=%tmpActionTimeOut%
win_title=%tmpwinTitle%
win_class=%tmpwinClass%
win_text=
win_exTitle=
win_exText=
cmd_runWait=%tmpcmdRunWait%
msg_show=%tmpmsgShow%
msg_timeout=%tmpmsgTimeOut%
cmd_processName=%tmpcmdProcess%
;Default Variables
var_waitPostRunMilliseconds=%usewaitPostRun%
var_WinWaitPIDSeconds=%useWinWaitPID%
var_WinWaitCLASSSeconds=%useWinWaitCLASS%
var_WinWaitTITLESeconds=%useWinWaitTITLE%
cmd_WorkingDirectory=
;AHK Default Settings
SetTitleMatchMode, 1
SetTitleMatchMode, Fast
ampl_TestMode:=true

; codeBefore
%tmpcodeBefore%

if cmdNone=0
{
	return_IDs:=ampl_ProcessCommand( step_title, "" , cmd_delayBefore , cmd_fullPath, cmd_parameters, cmd_WorkingDirectory, cmd_runWait , cmd_processName , cmd_delayAfter , win_moveDo , win_moveX , win_moveY , win_sizeDo , win_sizeW , win_sizeH, win_minMax, win_title, win_class, win_text, win_exTitle, win_exText, msg_show, msg_timeout, var_waitPostRunMilliseconds, var_WinWaitPIDSeconds, var_WinWaitCLASSSeconds, var_WinWaitTITLESeconds)
	ampl_ERROR:=ERRORLEVEL
	if(ampl_ERROR=101)
	{
	  if msg_show=1
	  	MsgBox,0,%step_title%, An error occured running %commandArray4%, %msg_timeout%
	} else if(ampl_ERROR=100)
	{
	  if msg_show=1
			msgbox,0,%step_title%, The Command Path has not been set correctly, %msg_timeout%
	} else
	{
		StringSplit, return_ID, return_IDs,~
		ampl_procID:=return_ID1
		ampl_WinID:=return_ID2
	}
}

; codeAfter
%tmpcodeAfter%

ampl_WaitForWindow( ampl_WinID , step_waitForTimeOut , step_waitFor )
ampl_ERROR+=ERRORLEVEL
ampl_FinalAction( step_actionWhen, ampl_ERROR , step_actionWhat , step_actionForce , step_actionTimeOut , ampl_WinID )
    ), %scriptTempPath%

SplitPath, scriptTempPath, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
pathScriptLog = %OutDir%\%OutNameNoExt%.log
IfExist, %pathScriptLog%
  FileDelete, %pathScriptLog%
d="
ahkPath= %d%%A_AhkPath%%d%
scriptTempPath = %d%%scriptTempPath%%d%
pathScriptLog=%d%%pathScriptLog%%d%
RunWait, %ahkPath% %scriptTempPath%,,UseErrorLevel,NewPID
If ERRORLEVEL=Error
  MsgBox, There was an error running the script

; View Log
;msgbox, Load %pathScriptLog%
MsgBox, 1, %thisScript_Name%, Do you want to view the log file?,
IfMsgBox, OK
	Run, %scriptEditor% %pathScriptLog%, , UseErrorLevel,
Return
EditCB:
	if(editingCB=false)
	{
	 GuiControl, , EditCB, load
	 editingCB:=true
	 ;MsgBox, Edit Code Before
	 GuiControlGet, edit_CB, , codeBefore,
	 IfExist, %A_Temp%\codeBefore.ahk
	 		FileDelete, %A_Temp%\codeBefore.ahk
	 FileAppend, %edit_CB%, %A_Temp%\codeBefore.ahk
	 CheckTime:=A_TICKCOUNT
	 RunWait, %scriptEditor% %A_Temp%\codeBefore.ahk, , UseErrorLevel,
	 ElapsedTime:=A_TICKCOUNT - CheckTime
	 if ElapsedTime>5000
	  Gosub, EditCB
	} else if(editingCB=true)
	{
	 GuiControl, , EditCB, edit
	 editingCB:=false
	 ;MsgBox, Load Code Before
	 FileRead, edit_CB, %A_Temp%\codeBefore.ahk
	 GuiControl, , codeBefore, %edit_CB%
	}
Return
AddV:
	; Get the main window's position
	WinGetPos, amplX, amplY, amplW, amplH, A

	GuiControlGet, variableNumber, , VariableToAdd,
	if variableNumber=
		return
	; Disable the window until the Plugin has finished
	GUI, 2: +Disabled
	SetTimer, WatchCursor , Off
	GuiControl, , VariableToAdd, |%listPlugins%

	usePrefix:= listPreFix%variableNumber%
	functionToCall:= usePrefix . "_GetFunction"
	functionText:=%functionToCall%(6 , amplX , amplY)
Return



VariableToAdd:
GuiControlGet, variableNumber, , VariableToAdd,
if variableNumber=
  GuiControl, Disable1, AddV,
else
  GuiControl, Enable1, AddV,
Return
EditCA:
       if(editingCA=false)
       {
         GuiControl, , EditCA, load
         editingCA:=true

         GuiControlGet, edit_CA, , codeAfter,
         IfExist, %A_Temp%\codeAfter.ahk
         		FileDelete, %A_Temp%\codeAfter.ahk
         FileAppend, %edit_CA%, %A_Temp%\codeAfter.ahk
         CheckTime:=A_TICKCOUNT
         RunWait, %scriptEditor% %A_Temp%\codeAfter.ahk, , UseErrorLevel,
				 ElapsedTime:=A_TICKCOUNT - CheckTime
				 if ElapsedTime>5000
          Gosub, EditCA
       } else if(editingCA=true)
       {
         GuiControl, , EditCA, edit
         editingCA:=false
         ;MsgBox, Load Code Before
         FileRead, edit_CA, %A_Temp%\codeAfter.ahk
         GuiControl, , codeAfter, %edit_CA%
       }
Return

RunCA:
	scriptTempPath=%A_Temp%\temp.ahk

  IfExist, %scriptTempPath%
    FileDelete, %scriptTempPath%

	GuiControlGet, tmpcodeBefore, 2:, codeBefore
	GuiControlGet, tmpcodeAfter, 2:, codeAfter
  GuiControlGet, tmpMsgShow, 2:, msgShow
  GuiControlGet, tmpmsgTimeOut, 2:, msgTimeOut
	GuiControlGet, tmpWinTitle, 2:, winTitle
	GuiControlGet, tmpWinClass, 2:, winClass
	GuiControlGet, tmpcmdProcess, 2:, cmdProcess
  GuiControlGet, tmpWinID,2:,win_PIDCheck
  GuiControlGet, tmpProcID,2:,run_PIDCheck

	if tmpWinID=
	{
    MsgBox, 1, %thisScript_Name%, The Check Window ID is empty!`nIf your code After uses the ampl_WinID or ampl_ProcID variables you will need to fill these with the Check Window function.`n`nRun Check Window function now?,
    IfMsgBox, OK
      Gosub, CheckWindow
	}

	commandArray4=

    SplitPath, tmpcmdPath, , , , , fileDrive

    FileAppend,
    (
win_title=%tmpwinTitle%
win_class=%tmpwinClass%
win_text=
win_exTitle=
win_exText=
cmd_runWait=%tmpcmdRunWait%
msg_show=%tmpmsgShow%
msg_timeout=%tmpmsgTimeOut%
cmd_processName=%tmpcmdProcess%
;Default Variables
var_waitPostRunMilliseconds=%usewaitPostRun%
var_WinWaitPIDSeconds=%useWinWaitPID%
var_WinWaitCLASSSeconds=%useWinWaitCLASS%
var_WinWaitTITLESeconds=%useWinWaitTITLE%
cmd_WorkingDirectory=
;AHK Default Settings
SetTitleMatchMode, 1
SetTitleMatchMode, Fast

; Values from CheckWindow
ampl_procID:=%tmpProcID%
ampl_WinID:=%tmpWinID%

; codeAfter
%tmpcodeAfter%
), %scriptTempPath%
SplitPath, scriptTempPath, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
pathScriptLog = %OutDir%\%OutNameNoExt%.log
IfExist, %pathScriptLog%
  FileDelete, %pathScriptLog%
d="
ahkPath= %d%%A_AhkPath%%d%
scriptTempPath = %d%%scriptTempPath%%d%
pathScriptLog=%d%%pathScriptLog%%d%
RunWait, %ahkPath% %scriptTempPath%,,UseErrorLevel,NewPID
If ERRORLEVEL=Error
  MsgBox, There was an error running the script

; View Log
;msgbox, Load %pathScriptLog%
MsgBox, 1, %thisScript_Name%, Do you want to view the log file?,
IfMsgBox, OK
	Run, %scriptEditor% %pathScriptLog%, , UseErrorLevel,

Return

2guiclose:
CancelScript:
	if (editingCA=true or editingCB=true)
	{
		msgbox, 53, %thisScript_Name%, You still have code being edited externally!`nSelect 'Retry' to return and check your code
		IfMsgBox, Retry
			return
	}

  GuiControlGet, original_cmd, 2:, cmdOriginal,
	tmpminmaxAfter:=PP()

  GuiControlGet, tmpstepTitle, 2:, stepTitle
	GuiControlGet, tmpfileName, 2:, fileName
	GuiControlGet, tmpdelayBefore, 2:, delayBefore
	GuiControlGet, tmpcmdPath, 2:, cmdPath
	GuiControlGet, tmpcmdParameter, 2:, cmdParameter
	GuiControlGet, tmpcmdProcess, 2: , cmdProcess
	GuiControlGet, tmpdelayAfter, 2:, delayAfter
	GuiControlGet, tmpMoveDo, 2:, MoveDo
	GuiControlGet, tmpMoveX, 2:, MoveX
	GuiControlGet, tmpMoveY, 2:, MoveY
	GuiControlGet, tmpSizeDo, 2:, SizeDo
	GuiControlGet, tmpSizeW, 2:, SizeW
	GuiControlGet, tmpSizeH, 2:, SizeH
	;GuiControlGet, commandArray13, 2:, minmaxAfter
  GuiControlGet, tmpWaitFor, 2:, WaitFor
  GuiControlGet, tmpwaitForTimeOut, 2:, waitForTimeOut
	GuiControlGet, tmpcodeBefore, 2:, codeBefore
	GuiControlGet, tmpcodeAfter, 2:, codeAfter
	GuiControlGet, tmpActionWhen, 2:, ActionWhen
	GuiControlGet, tmpActionWhat, 2:, ActionWhat
	GuiControlGet, tmpActionForce, 2:, ActionForce
	GuiControlGet, tmpActionTimeOut, 2:, actionTimeOut
  GuiControlGet, tmpcmdRunWait, 2:, cmdRunWait
  GuiControlGet, tmpCmdNone, 2:, CmdNone
  GuiControlGet, tmpMsgShow, 2:, msgShow
  GuiControlGet, tmpmsgTimeOut, 2:, msgTimeOut
	GuiControlGet, tmpwinTitle, 2:, winTitle
	GuiControlGet, tmpwinClass, 2:, winClass
	GuiControlGet, tmpiconListViewNumber, 2:, iconListViewNumber
	GuiControlGet, tmpiconPath, 2:, iconPath

	tmp_Object:=CompileCommandObject(tmpstepTitle , tmpfileName , tmpdelayBefore , tmpcmdPath, tmpcmdParameter, tmpcmdRunWait, tmpcmdProcess , tmpdelayAfter , tmpMoveDo , tmpMoveX , tmpMoveY , tmpSizeDo , tmpSizeW , tmpSizeH, tmpminmaxAfter, tmpwaitFor, tmpwaitForTimeOut , tmpactionWhen , tmpactionWhat , tmpactionForce , tmpactionTimeOut, tmpcodeBefore, tmpcodeAfter, tmpwinTitle , tmpwinClass , tmpiconListViewNumber , tmpiconPath , tmpcmdNone , tmpmsgShow, tmpmsgTimeOut)
	changesMade:=CompareObjects( original_cmd , tmp_Object)

  if(changesMade>0)
  {
  if changesMade>1
     numberChanged=%changesMade% changes
  else
     numberChanged=%changesMade% change

  MsgBox, 4, %thisScript_Name%, Are you sure you want to Cancel the %numberChanged%?`n%ERRORLEVEL%
  IfMsgBox, Yes
		{
     SetTimer, WatchCursor , Off
		 gui,2: Hide
		 Gui,1: Default
		 GUI, Show
		 gui, -Disabled
     GuiControl,, MessageFrame, Step %CommandBeingEdited% not saved!
		}
  } else
  {
     SetTimer, WatchCursor , Off
		 gui,2: Hide
		 Gui,1: Default
		 GUI, Show
		 gui, -Disabled
     GuiControl, , MessageFrame, Step %CommandBeingEdited% closed.
	}
  SetTimer, WatchCursorMain , 100
Return

PreDelay:
  GuiControl, , MessageFrame, Enter the delay in milliseconds to wait before the command is run.
  gosub  MakeChange
return

PP()
{
GuiControlGet, P1, 2:, minmaxAfter1
GuiControlGet, P2, 2:, minmaxAfter2
GuiControlGet, P3, 2:, minmaxAfter3
if P1=1
	Return 1
if P2=1
	Return 2
if P3=1
	Return 3

Return 0
}
UseNoCmd:
	gui, 2: Default
	GuiControlGet, tmpCmdNone, , CmdNone,
	GuiControlGet, tmpCmdRunWait, , cmdRunWait,

	doDisable:=(tmpCmdNone=1 or tmpCmdRunWait=1)

	GuiControl, Disable%doDisable%, GetCmd,
	GuiControl, Disable%doDisable%, GetFileParameter,
	GuiControl, Disable%doDisable%, cmdParameter,
	GuiControl, Disable%doDisable%, MoveDo,
	GuiControl, Disable%doDisable%, MoveX,
	GuiControl, Disable%doDisable%, MoveY,
	GuiControl, Disable%doDisable%, usePosition,
	GuiControl, Disable%doDisable%, useMonitor,
	GuiControl, Disable%doDisable%, SizeDo,
	GuiControl, Disable%doDisable%, SizeW,
	GuiControl, Disable%doDisable%, SizeH,
	GuiControl, Disable%doDisable%, minmaxAfter1,
	GuiControl, Disable%doDisable%, minmaxAfter2,
	GuiControl, Disable%doDisable%, minmaxAfter3,
	GuiControl, Disable%doDisable%, waitFor
	GuiControl, Disable%doDisable%, waitForTimeOut
	GuiControl, Disable%doDisable%, GrabDetails

	GuiControl, Disable%tmpCmdNone%, cmdRunWait,
	GuiControl, Disable%tmpCmdNone%, delayBefore,
	GuiControl, Disable%tmpCmdNone%, delayAfter,
	GuiControl, Disable%tmpCmdNone%, GetCmd,
	GuiControl, Disable%tmpCmdNone%, GetFileParameter,
	GuiControl, Disable%tmpCmdNone%, cmdParameter,

	GuiControl, Disable%tmpCmdRunWait%, cmdNone

Return

GrabDetails:
  getText:=GetKeyState("Shift")
  runcmd:=GetKeyState("Control")
  ;if(key_Shift = 1 ){
		;; Shift down; prompt to load file
		;getText:=true
		;} else
		;getText:=False

  GuiControlGet, fileToRun, 2:, cmdPath
if (runcmd=0) {
  IfNotExist, fileToRun
    (
			msgbox, Can't find %fileToRun%
			Return
		)

  GuiControlGet, useDoSize,2:, sizeDo
  GuiControlGet, useSizeW,2:,SizeW
  GuiControlGet, useSizeH,2:,SizeH
  GuiControlGet, useDoMove,2:, moveDo
  GuiControlGet, useMoveX,2:,MoveX
  GuiControlGet, useMoveY,2:,MoveY

  GuiControlGet, useParams, 2:, cmdParameter


  SplitPath, fileToRun, __fileName, fileDir
  if __fileName !=
    if cmdWorkingDirectory!=
      {
        if useParams!=
					fileToRun:= fileToRun . A_SPACE . linkArgs
      	Run, %fileToRun%, %cmdWorkingDirectory%,, NewPID
			}
    else
			Run, %fileToRun%,%fileDir%,,NewPID
	else
    Run, %fileToRun%, , , NewPID
  Sleep, 10
	;msgbox, %NewPID%
	if NewPID!=
	{
  	WinWait, ahk_pid %NewPID% , , 10
  	WinActivate, ahk_pid %NewPID% , , 10
  	if useDoMove>0
      WinMove, ahk_pid %NewPID%, , %useMoveX% , %useMoveY%
		if useDoSize>0
      WinMove, ahk_pid %NewPID%, , , , %useSizeW%, %useSizeH%
  }
	GuiControl,,run_PID, %NewPID%
	}
  MsgBox , 4097 , %thisScript_Name% , Please position the window and click OK
  IfMsgBox, OK
  {
	  WinGetActiveStats, winTitle, Width, Height, X, Y
	  WinGet, get_PID, ID, A


		if get_PID!=
		{
		  WinGet, cmdProcess, ProcessName, ahk_id %get_PID%
		}else {
			WinGet, cmdProcess, ProcessName, A
		}
	  WinGetClass, winClass, ahk_id %get_PID%
	  if(getText=true)
      WinGetText, winText, ahk_id %get_PID%


	  GuiControl, , MoveDo, 1
	  GuiControl, , MoveX , %X%
	  GuiControl, , MoveY , %Y%
	  GuiControl, , SizeDo, 1
	  GuiControl, , SizeW , %Width%
	  GuiControl, , SizeH , %Height%
		GuiControl,,winClass, %winClass%
		GuiControl,,winTitle, %winTitle%
		GuiControl,,cmdProcess, %cmdProcess%
		GuiControl,,win_PID, %get_PID%
		if WinText!=
			{
        GuiControlGet, CodeB, , codeBefore,
        GuiControl, , codeBefore, %codeB%`nwin_Text:=""`n/*Can be ONE or substring of the following:`n%WinText%*/
			}
		GoSub, MoveDo
		GoSub, usePosition
		GoSub, SizeDo
		gotWinDetails=1

		MsgBox, 4, %thisScript_Name%, Close %winTitle%?
		IfMsgBox, Yes
		  CloseWindow(  get_PID , winClass , winTitle )
	}

return

Cmd:
Return

PostDelay:
Return
MoveDo:
  GuiControlGet, MoveDoCheckState, 2:, MoveDo
  GuiControl,2: Enable%MoveDoCheckState%, MoveX
  GuiControl,2:  Enable%MoveDoCheckState%, MoveY
  GuiControl,2: Enable%MoveDoCheckState%, usePosition
  GuiControl,2: Enable%MoveDoCheckState%, useMonitor
  changesMade+=1
Return
SizeDo:
  GuiControlGet, SizeDoCheckState, 2:, SizeDo
  GuiControl,2: Enable%SizeDoCheckState%, SizeW
  GuiControl,2: Enable%SizeDoCheckState%, SizeH
  changesMade+=1
Return
msgShowClick:
	GuiControlGet, MsgShowState, 2:, msgShow
	GuiControl, 2: Enable%MsgShowState%, msgTimeOut
return
usePosition:
  GuiControlGet, usePositionSelected, 2:, usePosition
  if usePositionSelected=1
     usePositionSelected=0
  GuiControl,2: Enable%usePositionSelected%, useMonitor
  if usePositionSelected>0
     Gosub, CalculateXY
Return
SetForce:
	GuiControlGet, actionWhatState, 2:, actionWhat
	;msgbox, %actionWhatState%
	if (actionWhatState>1 and actionWhatState<5)
		GuiControl,2:,ForceLabel, Focus
	else
	  GuiControl,2:,ForceLabel, Force
Return
makeChange:
changesMade+=1
Return
CalculateXY:
  GuiControlGet, usePositionSelected, 2:, usePosition
  GuiControlGet, useMonitorSelected,2:, useMonitor
  GuiControlGet, useDoSize,2:, sizeDo
  useSizeH=0
  useSizeW=0
  if useDoSize>0
	{
	  GuiControlGet, useSizeW,2:,SizeW
	  GuiControlGet, useSizeH,2:,SizeH
	}
	SysGet, useMonitorArea, MonitorWorkArea, %useMonitorSelected%
	;msgbox, Monitor: Left=%useMonitorAreaLeft% Right=%useMonitorAreaRight%`nSize: W=%useSizeW% H=%useSizeH%

	if(usePositionSelected=3 || usePositionSelected=6 || usePositionSelected=9 )
	{
	 newX := Round(((useMonitorAreaRight - useMonitorAreaLeft) / 2 ) + useMonitorAreaLeft - (useSizeW / 2 ))
  }else if(usePositionSelected=2 || usePositionSelected=5 || usePositionSelected=8 )
  {
   newX := useMonitorAreaLeft
	} else if (usePositionSelected=4 || usePositionSelected=7 || usePositionSelected=10 )
	{
   newX := Round(useMonitorAreaRight - useSizeW )
	}
	if(usePositionSelected=2 || usePositionSelected=3 || usePositionSelected=4 )
	{
	 newY := useMonitorAreaTop
  }else if(usePositionSelected=5 || usePositionSelected=6 || usePositionSelected=7 )
  {
   newY := round(((useMonitorAreaBottom - useMonitorAreaTop) / 2 ) + useMonitorAreaTop - (useSizeH / 2) )
	} else if (usePositionSelected=8 || usePositionSelected=9 || usePositionSelected=10 )
	{
   newY := Round(useMonitorAreaBottom - useSizeH )
	}

	GUICONTROL, , MoveX , %newX%
  GuiControl, , MoveY, %newY%
Return

WatchCursor:
  MouseGetPos, , , winID, controlID, 1     ; Find WindowID and controlID under mouse
  WinGet, mePID, ID, %WinStepTitle%        ; Get AMPL Step windowID
  if winID=%mePID%                         ; If we're over the AMPL Step window
  {
  ;msgbox, Control: %controlID%
  if controlID=Edit1										; Pause Before
     GuiControl, 2:, MessageFrame, The title of the step.
  else if controlID=Edit2										; Pause Before
     GuiControl, 2:, MessageFrame, Enter the delay in milliseconds to wait before the command is run.`nMore complex waits can be performed using the codeBefore section.
	else if controlID=Edit3								; Cmd
     GuiControl, 2:, MessageFrame, This is the command that will be run.
	else if controlID=Button1								; Get Cmd button
     GuiControl, 2:, MessageFrame, Open a File Requester to select the command that will be run.`nUse SHIFT to select a Folder instead of a File.
	else if controlID=Edit4								; Parameters Field
     GuiControl, 2:, MessageFrame, Parameters
	else if controlID=Button2								; Parameters button
     GuiControl, 2:, MessageFrame, Open a File Requester to select a file and/or type into the field.`nUse SHIFT to select a Folder instead of a File.
	else if controlID=Static4								;
     GuiControl, 2:, MessageFrame, Settings for the move operation.
	else if controlID=ComboBox1								;
     GuiControl, 2:, MessageFrame, Select the type of move. Auto-Calculations for Top-Left...
	else if controlID=ComboBox2								; Monitor
     GuiControl, 2:, MessageFrame, Select the Monitor
	else if controlID=Button3								; getDetails
     GuiControl, 2:, MessageFrame, Enable Moving of the window.
	else if controlID=Edit5									; MoveX
     GuiControl, 2:, MessageFrame, The X coordinate. If blank then the current windown's current x coordinate will be used.
	else if controlID=Edit6									; MoveY
     GuiControl, 2:, MessageFrame, The Y coordinate. If blank then the current windown's current y coordinate will be used.
	else if controlID=Button4								; doSize
     GuiControl, 2:, MessageFrame, Enable sizing of the window.
	else if controlID=Edit7									; SizeW
     GuiControl, 2:, MessageFrame, The new width of the window.
	else if controlID=Edit8										; SizeH
     GuiControl, 2:, MessageFrame, The new Height of the window.
	else if controlID=Static7										; SizeLabel
     GuiControl, 2:, MessageFrame, Settings for the Size operation
	else if controlID=Static8										; minmaxAfter Label
     GuiControl, 2:, MessageFrame, Settings for maximizing or minimizing the window.
	else if controlID=Button6										; minmaxAfter::None
     GuiControl, 2:, MessageFrame, Do nothing.
	else if controlID=Button7									; minmaxAfter::Minimize
     GuiControl, 2:, MessageFrame, Minimize the window.
	else if controlID=Button8										; minmaxAfter::Maximize
     GuiControl, 2:, MessageFrame, Maximize the window.
	else if controlID=Button5										; GetDetails
     GuiControl, 2:, MessageFrame, Runs command so that it can be positioned and sized. Also gets other window details that are important for the other window commands. Run command and get window details. Hold SHIFT down to also grab the window text elements.
	else if controlID=Edit9										; Pause after
     GuiControl, 2:, MessageFrame, Enter the delay in milliseconds to wait after the command is run.`nMore complex waits can be performed using the codeAfter section.
	else if controlID=Button9										; msgShow
     GuiControl, 2:, MessageFrame, When enabled error messages will display.
	else if controlID=Edit10										; msgTimeOut
     GuiControl, 2:, MessageFrame, Timeout in seconds that the MessageBox will wait.`n0 will wait indefinately.
	else if controlID=Edit11										; codeBefore
     GuiControl, 2:, MessageFrame, AHK code that will be executed before the command will run.
	else if controlID=ComboBox3										; actionWhat
     GuiControl, 2:, MessageFrame, Plugin to run: Select the Plugin and click the "a" for Add button.
	else if controlID=Button10										; add Variable
     GuiControl, 2:, MessageFrame, This button will add the variable selected.
	else if controlID=Button11										; editCodeBefore
     GuiControl, 2:, MessageFrame, This button will launch the system text editor, or that defined, and load the codeBefore section.`nThe code can be loaded back in by clicking the button again.
	else if controlID=Button12										; cmdWait
     GuiControl, 2:, MessageFrame, When enabled, AMPL will wait for the command to finish before continuing.`nThis setting essentially excludes the window manipulation commands.
	else if controlID=Button13										; cmdNone
     GuiControl, 2:, MessageFrame, When enabled no command will be run. This setting is only useful if the codeBefore or codeAfter sections are used.
	else if controlID=Edit12										; codeBefore
     GuiControl, 2:, MessageFrame, AHK code that will be executed after the command has run.
	else if controlID=Button14										; editCodeAfter
     GuiControl, 2:, MessageFrame, This button will test just the code After section. This can be helpful when testing a complex Step.
	else if controlID=Button15										; editCodeAfter
     GuiControl, 2:, MessageFrame, This button will launch the system text editor, or that defined, and load the codeAfter section.`nThe code can be loaded back in by clicking the button again.
	else if controlID=ComboBox4										; waitFor
     GuiControl, 2:, MessageFrame, Wait For Window Action: After the command has run the script can wait for the window to become inactive or closed, with an optional timeout. It the window can't be found a failure is returned.
	else if controlID=Edit13										; waitForTimeOut
     GuiControl, 2:, MessageFrame, The number of seconds to wait before the waitFor command timesout. If the waitFor command timesout an error will be returned.
	else if controlID=ComboBox5										; actionWhen
     GuiControl, 2:, MessageFrame, Success Level: During execution of the script the error levels are summed. This command will allow the execution of code based on that sum: Success=0,Error<100,Failure>=100.
	else if controlID=ComboBox6										; actionWhat
     GuiControl, 2:, MessageFrame, Script Action: The action to take based on the Success Level.
	else if controlID=Button16										; actionForce
     GuiControl, 2:, MessageFrame, This setting only is applicable to the Shutdown, Logoff, Reboot & Powerdown commands. The "Force" command forces all open applications to close. It should only be used in an emergency because it may cause any open applications to lose data.
	else if controlID=Edit14										; actionTimeOut
     GuiControl, 2:, MessageFrame, Timeout in seconds that the warning MessageBox will wait.`n0 will wait indefinately.
	else if controlID=Edit15										; Window : Script : Title
     GuiControl, 2:, MessageFrame,The Title of the window AMPL will be looking for: not editable. If you need to change this add win_title:="New Window Title" to the Code Before section.
	else if controlID=Edit16										; Window : Script : Class
     GuiControl, 2:, MessageFrame,The Class of the window AMPL will be looking for: not editable. This value is added when the "Grab Window Details" function is used.
	else if controlID=Edit17										; Window : Script : Cmd PID
     GuiControl, 2:, MessageFrame,The unique ID of the Programme that was run: not editable. This value is added when the "Grab Window Details" function is used.
	else if controlID=Edit18										; Window : Script : Process
     GuiControl, 2:, MessageFrame,The Process Name of the Programme that was run: not editable. This value is added when the "Grab Window Details" function is used.
	else if controlID=Edit19										; Window : Script : FileName
     GuiControl, 2:, MessageFrame,The File Name of the Programme that was run: not editable. This value is added when the "Grab Window Details" function is used.
	else if controlID=Edit20										; Window : Script : Win ID
     GuiControl, 2:, MessageFrame,The unique ID of the Window that was run: not editable. This value is added when the "Grab Window Details" function is used.
	else if controlID=Edit24										; Window : Check : Title
     GuiControl, 2:, MessageFrame,The Title of the window that was just checked. This value is added when the "Check Window" function is used.
	else if controlID=Edit25										; Window : Check : Class
     GuiControl, 2:, MessageFrame,The Class of the window that was just checked. This value is added when the "Check Window" function is used.
	else if controlID=Edit26										; Window : Check : Cmd PID
     GuiControl, 2:, MessageFrame,The unique ID of the Programme that was just checked. This value is added when the "Check Window" function is used.
	else if controlID=Edit27										; Window : Check : Process
     GuiControl, 2:, MessageFrame,The Process Name of the Window that was just checked. This value is added when the "Check Window" function is used.
	else if controlID=Edit28										; Window : Check : FileName
     GuiControl, 2:, MessageFrame,This is always blank (makes you wonder why it's here...).
	else if controlID=Edit29										; Window : Check : Win ID
     GuiControl, 2:, MessageFrame,The unique ID of the Window that was just checked. This value is added when the "Check Window" function is used.
	else if controlID=Button17										; check Window
     GuiControl, 2:, MessageFrame, Check an open window and load data into check section.
	else if controlID=Edit30										; messageFrame
     GuiControl, 2:, MessageFrame, This is the very helpful Message Frame, which will hopefully help you fing your way around the ScriptEditor window.
	else if controlID=Button18										; actionForce
     GuiControl, 2:, MessageFrame, Run AMPL Recorder. Recorded script can be inserted into the code Before or code After section from AMPL Recorder.
	else if controlID=Button19										; actionForce
     GuiControl, 2:, MessageFrame, Run Window Spy.
	else if controlID=Button20										; actionForce
     GuiControl, 2:, MessageFrame, AutoHotKey Help.
	else if controlID=Button21										; actionForce
     GuiControl, 2:, MessageFrame, Test Step.
	else if controlID=Button22										; actionForce
     GuiControl, 2:, MessageFrame, Delete Step and close window.
	else if controlID=Button23										; actionForce
     GuiControl, 2:, MessageFrame, Cancel Step and close window.
	else if controlID=Button24										; actionForce
     GuiControl, 2:, MessageFrame, Save Step and close window.
	else {
     GuiControl, 2:, MessageFrame,
     ;if controlID!=
     	;msgbox,Class: %controlID%
     }
 }
Return
/*
** ********************************************************************************
** Step Window :: Button Routines
** ********************************************************************************
*/
RunScriptWriter:
  ;MsgBox, Run Script Writer
  IfExist, %A_ScriptDir%\AMPLRecorder.ahk
    Run, %A_ScriptDir%\AMPLRecorder.ahk
  Else
    MsgBox, Can't find Recorder.ahk!`nAMPL requires a standard setup and is currently looking in %A_ScriptDir%
Return

RunWindowSpy:
  ;MsgBox, Run Window Spy
  IfExist, %ahkDirectory%\AU3_Spy.exe
    Run, %ahkDirectory%\AU3_Spy.exe
  Else
    MsgBox, Can't find Window Spy!`nAMPL requires a standard setup and is currently looking in %ahkDirectory%
Return

RunHelp:
  WinGet, mePID, PID, A
  ;msgbox, PID: %mePID%
  Run, %ahkDirectory%\AutoHotkey.chm , , , ahkHelp
  WinWait, AutoHotkey Help
  WinActivate, AutoHotkey Help
  WinGet, ampl_PID, PID, A
  ;msgbox, Help: %ampl_PID%
  WinGetPos, meX, meY, meWidth, , ahk_pid %mePID%
  ;msgbox, X:%meX% Y:%meY% W:%meWidth%
  newX:=meX+meWidth+1
  newY:=meY
  if newX>%A_ScreenWidth%
		newW:=A_ScreenWidth-(newX- A_ScreenWidth)
		else
		 newW:=A_ScreenWidth-newX
  newH:=A_ScreenHeight-newY
  ;msgbox, %ampl_PID% X:%newX% Y:%newY%  W:%newW%  H:%newH%
  WinMove, AutoHotkey Help, , %newX%, %newY% , %newW% , %newH%
  ;MsgBox, Error: %ERRORLEVEL%
Return
ClearScript:
	MsgBox, 4, %thisScript_Name%, Are you sure you want to remove this Step?,
  IfMsgBox, No
    Return

	gui,2: Hide

  StringSplit, cla, commandList, `n,
  newCommandList=
  CommandBeingEdited := CommandBeingEdited * 1
  Loop, %cla0%
  {
		if (A_INDEX = CommandBeingEdited)
		  {
		    ;Skip this one
			}
		else
		  {
		    thisObj:=cla%A_INDEX%
		    if (StrLen(thisObj)>0)
		    {
		    	newCommandList = %newCommandList%%thisObj%`n
				}
			}
	}
	commandList = %newCommandList%
	GUICONTROL, -ReDraw, MyListView

	GUI 1: Default
	GUI, Show
	gui, -Disabled

	; Update the ListView title
	LV_Delete(CommandBeingEdited)
	GuiControl, +ReDraw, MyListView
	LV_ModifyCol()

Return

SaveStep:
	; Check that we have a commandO
	GuiControlGet, tmpcmdPath, 2:, cmdPath
  GuiControlGet, tmpCmdNone, 2:, CmdNone

	if tmpcmdPath=
	{
		if(tmpCmdNone=0)
		{
      MsgBox, 48 , %thisScript_Name%, Either enter a Command or Specify 'No Command'
      Return
		}
	}
	; Have the Window's Details been got?
	if gotWinDetails=0 and tmpCmdNone=0
	{
    MsgBox, 53, %thisScript_Name%, You have not Got the Window's Details!`nIf you are going to use any of the other window commands it is highly recommended to get these details as it helps the script function.`nSelect 'Retry' to Return.
    IfMsgBox, Retry
      Return
	}
	if (editingCA=true or editingCB=true)
	{
		msgbox, 53, %thisScript_Name%, You still have code being edited externally!`nSelect 'Retry' to return and check your code
		IfMsgBox, Retry
			return
	}
  SetTimer, WatchCursor , Off

	postP:=PP()
	gui,2: submit

	obj := CompileCommandObject( stepTitle , fileName , delayBefore , cmdPath, cmdParameter, cmdRunWait, cmdProcess , delayAfter , MoveDo , MoveX , MoveY , SizeDo , SizeW , SizeH, postP, waitFor, waitForTimeOut , actionWhen , actionWhat , actionForce , actionTimeOut, codeBefore, codeAfter, winTitle , winClass , iconListViewNumber , iconPath , cmdNone , msgShow, msgTimeOut)
	;msgbox, %obj%
	;gui,2: Hide
  StringSplit, cla, commandList, `n,
  newCommandList=
  CommandBeingEdited := CommandBeingEdited * 1
  Loop, %cla0%
  {
  ;MsgBox, %A_INDEX%`n%CommandBeingEdited%
		if (A_INDEX = CommandBeingEdited)
		  {
		    ; This is the edited step: Write this one
				newCommandList = %newCommandList%%obj%`n
			}
		else
		  {
        ; Copy this object
		    thisObj:=cla%A_INDEX%
		    if (StrLen(thisObj)>0)
		    {
		      ; if anything's here: add it to the list
		    	newCommandList = %newCommandList%%thisObj%`n
				}
			}
	}
	commandList = %newCommandList%

	GUICONTROL, -ReDraw, MyListView

	GUI 1: Default
	GUI, Show
	gui, -Disabled
/*	; Update the ListView title
	iln:=GetField(obj,#iconListViewNumber,characterSeparator)
	newTitle:=GetField(obj,#stepTitle,characterSeparator)
	LV_Modify(CommandBeingEdited, "Icon" . iln , newTitle)
	scriptHasChanged+=1

	GuiControl, +ReDraw, MyListView
	LV_ModifyCol()
	if LV_GetCount()=1
	  cmdNone:=GetField( commandList , 28 ,characterSeparator)
	use_Toggle:= (cmdNone=0 || LV_GetCount()>1 ) ? 0 : 1
	GuiControl, Show%use_Toggle%, ToggleWindow
	*/
  Gosub, DrawMainWindow
	GuiControl,,MessageFrame, Saved: %newTitle% (Step %CommandBeingEdited%)

Return

/*
** ********************************************************************************
** Functions
** ********************************************************************************
*/
CompareObjects(o,t)
{
	Global characterSeparator
  StringSplit, o_array, o, %characterSeparator%,
  StringSplit, t_array, t, %characterSeparator%,
  Changes:=0
  ChangesString=

  Loop, %o_array0%
  {
    thisField:=o_array%A_INDEX%
    thatField:=t_array%A_INDEX%

    if(thisField!=thatField)
    {
      Changes+=1
      ChangesString.="[" . thisField . "!=" . thatField . "] "
    }
  }

	ERRORLEVEL:=ChangesString
  Return, Changes

}
CloseWindow( winPID , winClass , winTitle )
{
  ;MsgBox, PID: %winPID%`nClass: %winClass%`nTitle: %winTitle%
	if winPID!=
	  {
      WinClose, ahk_id %winPID% , , 3
      if ERRORLEVEL
      {
      	MsgBox, Error Closing Window: %ERRORLEVEL%
      	WINKILL, ahk_id %winPID%
      }
		} else {
		  if winClass!=
      	WinClose, %WinTitle% ahk_class %winClass%, , 3
			else
      	WinClose, %WinTitle% , , 3
      if ERRORLEVEL
      	MsgBox, Error Closing Window: %ERRORLEVEL%
		}
}
GetFieldNumber(f) {
global commandObject, characterSeparator
  Return , GetField(commandObject,f,characterSeparator)
}
GetVariableValue(v) {
;global
	return_Value:=%v%
  Return , return_Value
}
GetAMPLScript(){
global amplDirectory, thisScript_Name
   HWND          := WinExist(A)

   Filter        := "Autohotkey Files (*.ahk)"

   defaultFilter := 1
   IniDir        := amplDirectory . "\Scripts"
   DialogTitle   := thisScript_Name . " - Choose an AMPL Script"
   defaultExt    := "ahk"
   flags         := "FILEMUSTEXIST HIDEREADONLY NOCHANGEDIR NONETWORKBUTTON"

   Return DLG_FileOpen( HWND
                            , Filter
                            , defaultFilter
                            , IniDir
                            , DialogTitle
                            , defaultExt
                            , flags )
}
GetProgrammeFile(){
global amplDirectory, thisScript_Name
   HWND          := WinExist(A)

   Filter        := "Executable Files (*.exe)"
   Filter        .= "|Autohotkey Scripts (*.ahk)"
   Filter        .= "|AutoIT v3 Scripts (*.au3)"
   Filter        .= "|Other Script Files (*.vbs;*.js;*.bat)"
   Filter        .= "|All Files (*.*)"

   defaultFilter := 1
   IniDir        := A_ProgramFiles
   DialogTitle   := thisScript_Name . " - Choose Programme to Load"
   defaultExt    := "exe"
   flags         := "FILEMUSTEXIST NOCHANGEDIR"

   Return DLG_FileOpen( HWND
                            , Filter
                            , defaultFilter
                            , IniDir
                            , DialogTitle
                            , defaultExt
                            , flags )
}
GetAnyFiles(){
global amplDirectory, thisScript_Name
myDocs:=A_MyDocuments
if( SubStr( myDocs , StrLen(myDocs) ) !="\" )
	myDocs.="\"

   HWND          := WinExist(A)

   Filter        := "All Files (*.*)"

   defaultFilter := 1
   IniDir        := myDocs
   DialogTitle   := thisScript_Name . " - Choose a File"
   ;defaultExt    := "exe"
   flags         := "NOCHANGEDIR CREATEPROMPT DONTADDTORECENT PATHMUSTEXIST ALLOWMULTISELECT EXPLORER"

   Return DLG_FileOpen( HWND
                            , Filter
                            , defaultFilter
                            , IniDir
                            , DialogTitle
                            , defaultExt
                            , flags )
}
;
; Function: AddFunctionText
; Description:
;		Appends text to the codeBefore & codeAfter sections
; Syntax: AddFunctionText( thisPrefix , addCodeBefore , addCodeAfter)
; Parameters:
;		thisPrefix - The Library PREFIX
;		addCodeBefore - The formatted text to add to the codeBefore section
;   addCodeAfter - The formatted text to add to the codeAfter section
; Return Value:
;		None.
; Remarks:
;		This function also calls _IncludeDirective from the Plugin Library, which returns text for the Include Statement. The Plugin Library must manage if the include statement has been included, so as not to include it more than once.
;   This function will add the Include Statement to the begining of the codeBefore section and the addCodeBefore to the end. If _IncludeDirective returns "" an Inculde statement will not be added.
; Related: _IncludeDirective
; Example:
;		AddFunctionText( "WAIT" , "; WAIT Example")
;
AddFunctionText(thisPrefix , addCodeBefore , addCodeAfter="") {
global amplDirectory, WinStepTitle
Gui, 2: Default
GuiControlGet, codeB, , codeBefore,
GuiControlGet, codeA, , codeAfter,
Gui, -Disabled
newline=`n
includeText=
	functionToCall:= thisPrefix . "_IncludeDirective"
	if addCodeBefore!=
	{
		includeDirective:=%functionToCall%()
		if includeDirective!=
			includeText:="#Include " . amplDirectory . "\scripts\Includes\" . includeDirective . newLine

		newCodeBefore:= includeText . codeB . newline . addCodeBefore
		GuiControl, , codeBefore, %newCodeBefore%
	}
	if addCodeAfter!=
	{
		newCodeAfter:= codeA . newline . addCodeAfter
		GuiControl, , codeAfter, %newCodeAfter%
	}

	Gosub, VariableToAdd
  SetTimer, WatchCursor , On
  WinActivate , %WinStepTitle%, , ,
}
SetFieldValues(thisFieldValueCSV) {
Gui, 2: Default
Loop, Parse, thisFieldValueCSV , |
	{
	  StringSplit, thisFieldValue, A_LoopField , = ,
		if thisFieldValue1=COMMAND
		{
		  fileToRun:=thisFieldValue2
  		SplitPath, fileToRun, fileName, filePath, fileExtension, ,
  		
			GuiControl,, cmdPath,%fileToRun%
			GuiControl,,fileName,%fileName%

			iconListViewNumber:=LoadIcon(fileToRun)
			iconPath=%ERRORLEVEL%

			GuiControl,,iconPath,%iconPath%
			GuiControl,,iconListViewNumber,%iconListViewNumber%
			GuiControl,,LargeIcon,*x6 *y3 *w32 *h32 %iconPath%

		  GuiControlGet, oldstepTitle, 2:, stepTitle
		  ; Add Process Name if not changed
		  if SubStr(oldstepTitle, 1, 8) = "New Step" || InStr(oldstepTitle, ".exe") > 0
		     GuiControl, , stepTitle, %fileName%
		  GuiControl, Enable, GrabDetails
		  GuiControl, Enable, cmdParameter
		  GuiControl, Enable, GetFileParameter
		}
		if thisFieldValue1=NOCOMMAND
		{
			GuiControl, , CmdNone, %thisFieldValue2%
      Gosub, UseNoCmd
		}
		if thisFieldValue1=TEST
      MsgBox, 0, %thisFieldValue1%, %thisFieldValue2%, 5
	}


}
