/*
Script Editor Settings

*/
amplScriptName=AMPL Script Editor Settings
amplScriptVersion=0.1.0
amplScriptVersionDate=2009.06.14
amplScriptAuthor=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

/*
**********************************************************************************
** 	Version History
**********************************************************************************
**  0.1.x
**		! Fixed path issues
**	0.1.0	2009.06.14
**    Initial Release
**********************************************************************************
*/

Menu, tray, icon, %A_ScriptDir%\icons\Settings.ico
pluginBeingEdited=
entryBeingEdited=
scriptEditor=
SplitPath, A_SCRIPTDIR, , amplDirectory, , ,
directory_Icons:=A_ScriptDir . "\icons\filetypes\"
directory_Includes:=amplDirectory . "\scripts\includes\"
directory_FunctionDefinitions:=A_ScriptDir . "\includes\"

IniRead, scriptEditor, %A_ScriptDir%\ScriptEditor.ini, editor, ahk, notepad.exe
IniRead, useLogging, %A_ScriptDir%\ScriptEditor.ini, defaults, logging, 0
IniRead, editorwindow, %A_ScriptDir%\ScriptEditor.ini, defaults, editorwindow, 3

iconsFileTypes=
; Loop through the icon files on the system
Loop, %A_ScriptDir%\icons\filetypes\*.ico, , 0  ; Recurse into subfolders.
{
	; Check the ini for what extensions to use this for
	IniRead, extensions, %A_ScriptDir%\ScriptEditor.ini, filetypes, %A_LOOPFILENAME%
	if( extensions <> "ERROR" and extensions <> "" )
	  {
	    ;record=graphic.ico|jpg|png|bmp
			iconsFileTypes=%iconsFileTypes%%A_LOOPFILENAME%~%extensions%|`n
		}
}

listviewItem=0
countLibrary=0
Loop
{
	IniRead, prefixLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, prefix,
	IniRead, labelLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, label,
	IniRead, functionLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, functions,
	IniRead, includeLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, includes,
	IniRead, enableLibrary, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, enabled,

	If prefixLibrary = ERROR
		break

	countLibrary+=1
	listPreFix%countLibrary%:=prefixLibrary
	listfunctionLibrary%countLibrary%:=functionLibrary
	listLabel%countLibrary%:=labelLibrary
	listEnable%countLibrary%:=enableLibrary
	listIncludes%countLibrary%:=includeLibrary

}
listPreFix0:=countLibrary
listFileLibrary0:=countLibrary
listLabel0:=countLibrary
listEnable0:=countLibrary
listIncludes0:=countLibrary

windowList=Advanced|Simple|Ask


Gui, Font, S12 CDefault Bold, Verdana
Gui, Add, Text, x64 y20 w h , %amplScriptName%
Gui, Font, NORM s8,
Gui, Add, Picture, x3 y3 w48 h48, %A_ScriptDir%\icons\Settings.ico
gui, Add, Text,x10 ,Log by default
gui, add, Checkbox, xp+100 yp Checked%useLogging% vuseLogging,
gui, add, text,x10,Text Editor
gui, add, edit, xp+100 yp w150 vscriptEditor , %scriptEditor%
Gui, Add, Button, xp+160 yp w35 h20 vGetCmd gGetCommand, ...
gui, add, text, x10,Default Window
gui, add, DropdownList, xp+100 yp w150 AltSubmit Choose%editorwindow% veditorwindow, %windowList%
Gui, Add, Tab2, x4 w320 h285,FileType Icons|Plugins
Gui, Add, ListView, x+10 r10 w295 vMyListView gMyListView -Multi, Extensions
ImageListID:=IL_Create(10,10, 1)
;MsgBox, ImageList: %ImageListID%
success:=LV_SetImageList(ImageListID,1)
;MsgBox, Set ImageList: %success%
Loop, Parse, iconsFileTypes, `n, 
{
	StringSplit, iconDef, A_LOOPFIELD, ~,
	if (iconDef0=2)
	{
	  pathIcon := A_ScriptDir . "\icons\filetypes\" . iconDef1
  	;MsgBox, %pathIcon%
    iconID:=IL_Add(ImageListID, pathIcon , 1 ,0)
		;if iconID=0
      ;MsgBox, Error loading Icon
    LV_Add("Icon" . iconID ,iconDef2)
	}
}

gui, Add, text, xp yp+170,Icon Path
gui, Add, edit, xp+70 yp w180 viconPath,
Gui, Add, Button, xp+190 yp w35 h20 vGetIcon gGetIcon, ...
Gui, Add, text,x16 yp+30,Extensions
Gui, Add, Edit, xp+70 yp w180 vfileExtensions,
Gui, Add, Button, xp yp+25 w55 h20 vAddIcon gAddIcon, Add
Gui, Tab, 2
GUI, Add, ListView, x+10 r5 w295 vFunctionPlugins gFunctionPlugins -Multi, Plugin
Loop, %listPreFix0%
{
	thisfunctionLibrary:=listfunctionLibrary%A_INDEX%
	LV_Add("" , thisfunctionLibrary)
}
gui, add, Checkbox, xp yp+100 Checked%useLogging% vpluginEnabled,Plugin Enabled
Gui, Add, Text, xp yp+20,Definition
Gui, Add, Edit, xp+60 yp-2 w200 ReadOnly vFunctionFile
Gui, Add, Button, xp+205 yp w35 h20 vGetFunction gGetFunction, ...
Gui, Add, Text, x16 yp+25,Library
Gui, Add, Edit, xp+60 yp-2 w200 ReadOnly vLibraryFile
Gui, Add, Button, xp+205 yp w35 h20 vGetLibrary gGetLibrary, ...
Gui, Add, Text, x16 yp+25,PreFix
Gui, Add, Edit, xp+60 yp-2 w200 ReadOnly vLibraryPreFix
Gui, Add, Text, x16 yp+25,Label
Gui, Add, Edit, xp+60 yp-2 w200  vLibraryLabel
Gui, Add, Button, xp yp+30 w55 h20 vAddPlugin gAddPlugin, Add
Gui, Add, Button, xp+65 yp w55 h20 vDelPlugin gDelPlugin, Del
Gui, Add, Button, xp+65 yp w55 h20 vAboutPlugin gAboutPlugin, About
Gui, Tab
Gui, Add, Button, x15 y435 w70 h21 vSaveSettings gSaveSettings, Save
GUI, Show


Return

WriteTheFile:

Return

MyListView:
if A_GuiEvent=DoubleClick
{
	entryBeingEdited:=A_eventinfo
  StringSplit, iconsArray, iconsFileTypes , `n, ,
  fileDefinition:=iconsArray%A_EventInfo%
  StringSplit, iconDefinition, fileDefinition , ~, ,
  GuiControl, , iconPath , %iconDefinition1%
  GuiControl, , fileExtensions , %iconDefinition2%
  GuiControl, , AddIcon, Update
}
Return
GetCommand:
Return
GetIcon:

FileSelectFile, selectIcon, 3, , Open an icon, Icons (*.ico)
if selectIcon!=
{
  SplitPath, selectIcon , OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
  ;MsgBox, Dir: %OutDir%
  if (OutDir!=directory_Icons)
  {
    FileCopy, %selectIcon%, %directory_Icons%
	}
  GuiControl, , iconPath , %OutFileName%
}

Return
AddIcon:
newline=`n
newIconFileTypes=
GuiControlGet, thisIconPath , , iconPath
GuiControlGet, thisFileExtensions , , fileExtensions
StringSplit, saveIcons, iconsFileTypes , `n, ,
	gui, ListView, MyListView
if entryBeingEdited!=
{
	Loop , %saveIcons0%
	{
		if (entryBeingEdited = A_INDEX)
		{

		  pathIcon := A_ScriptDir . "\icons\filetypes\" . iconDef1
	  	;MsgBox, %pathIcon%
	    iconID:=IL_Add(ImageListID, pathIcon , 1 ,0)

			newIconFileTypes.= thisIconPath . "~" . thisFileExtensions . newline
		} else
		{
	    thisObj:=saveIcons%A_INDEX%
	    if (StrLen(thisObj)>0)
	    {
	      ; if anything's here: add it to the list
				newIconFileTypes.= thisObj . newline
	    	;newCommandList = %newCommandList%%thisObj%`n
			}
		}
	}
	iconsFileTypes:=newIconFileTypes
	GuiControl, -Redraw, MyListView
	success:=LV_Modify(entryBeingEdited, "Vis", thisFileExtensions)
	GuiControl, +Redraw, MyListView
} else if thisIconPath!=
	{
	  pathIcon := A_ScriptDir . "\icons\filetypes\" . thisIconPath
    ;MsgBox, icon: %pathIcon%
    iconID:=IL_Add(ImageListID, pathIcon , 1 ,0)
    ;MsgBox, IconID: %iconID%
	success:=LV_Add("Icon" . iconID ,thisFileExtensions)
  ;MsgBox, Success: %success%
	iconsFileTypes.=thisIconPath . "~" . thisFileExtensions . newline
}
GuiControl, , AddIcon , Add
  GuiControl, , iconPath , 
  GuiControl, , fileExtensions , 
  entryBeingEdited=
Return
guiclose:
ExitApp, 0
Return
FunctionPlugins:
if A_GuiEvent=DoubleClick
{
	pluginBeingEdited:=A_eventinfo
	thisLibrary:=listfunctionLibrary%pluginBeingEdited%
	thisInclude:=listIncludes%pluginBeingEdited%
	thisPreFix:=listPreFix%pluginBeingEdited%
	thisEnable:=listEnable%pluginBeingEdited%
	thisLabel:=listLabel%pluginBeingEdited%
  GuiControl, , libraryfile , %thisInclude%
  GuiControl, , FunctionFile, %thisLibrary%
  GuiControl, , LibraryLabel, %thisLabel%
	GuiControl, , pluginEnabled, %thisEnable%
	GuiControl, , LibraryPreFix, %thisPreFix%
	GuiControl, , AddPlugin, Update
}

Return
GetFunction:
FileSelectFile, selectFunction, 3, , Open an AMPL Function Detinition, AMPL Function Def (*_Definitions.ahk)
if selectFunction!=
{
  SplitPath, selectFunction , OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
  if (OutDir!=directory_FunctionDefinitions)
  {
    FileCopy, %selectFunction%, %directory_FunctionDefinitions%
	}
  GuiControl, , FunctionFile , %OutFileName%
  doneThis:=False
  inHeader:=False
  Loop, Read, %selectFunction% 
  {
    IfInString, A_LOOPREADLINE, START AMPL Definition Header
    {
			inHeader:=True
		} else if (inHeader=True)
		{
	    IfInString, A_LOOPREADLINE, Prefix=
	    {
	      StringSplit, Array, A_LOOPREADLINE , =,
				thisPreFix:=Array2
	      GuiControl, , LibraryPreFix , %thisPreFix%
			}
	    IfInString, A_LOOPREADLINE, Label=
	    {
	      StringSplit, Array, A_LOOPREADLINE , =,
				thisLabel:=Array2
	      GuiControl, , LibraryLabel , %thisLabel%
			}
	    IfInString, A_LOOPREADLINE, END AMPL Definition Header
	    {
				break
			}
;			if(thisLabel!="" and thisPreFix!=)
;			  break
		}
  }
}
Return
GetLibrary:
FileSelectFile, selectLibrary, 3, , Open an AMPL Function Library, AMPL Function Library (*_Includes.ahk)
if selectLibrary!=
{
  SplitPath, selectLibrary , OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
  if (OutDir!=directory_Includes)
  {
    FileCopy, %selectLibrary%, %directory_Includes%
	}
  GuiControl, , libraryfile , %OutFileName%
}
Return
AddPlugin:
 GuiControlGet, thisEnable , , pluginEnabled,
 GuiControlGet, thisLibrary , , FunctionFile
 GuiControlGet, thisInclude, , libraryfile
 GuiControlGet, thisLabel,,LibraryLabel
 GuiControlGet, thisPreFix,, LibraryPreFix
if pluginBeingEdited!=
{
 listfunctionLibrary%pluginBeingEdited%:=thisLibrary
 listPreFix%pluginBeingEdited%:=thisPreFix
 listLabel%pluginBeingEdited%:=thisLabel
 listEnable%pluginBeingEdited%:=thisEnable
 listIncludes%pluginBeingEdited%:=thisInclude
  GuiControl, , libraryfile , 
  GuiControl, , FunctionFile, 
  GuiControl, , LibraryLabel, 
	GuiControl, , pluginEnabled, 0
	GuiControl, , LibraryPreFix, 
	GuiControl, , AddPlugin, Add
	LV_Modify(pluginBeingEdited ,"Vis" , thisLibrary)
} else if( thisLibrary!="" and thisInclude!="" and thisLabel!="" ) {
 pluginBeingEdited:=LV_GetCount() + 1
  ;MsgBox, Rows: %pluginBeingEdited%
  countLibrary:=pluginBeingEdited
 listfunctionLibrary%pluginBeingEdited%:=thisLibrary
 listPreFix%pluginBeingEdited%:=thisPreFix
 listLabel%pluginBeingEdited%:=thisLabel
 listEnable%pluginBeingEdited%:=thisEnable
 listIncludes%pluginBeingEdited%:=thisInclude
 LV_Add("Vis" , thisLibrary)
  GuiControl, , libraryfile ,
  GuiControl, , FunctionFile,
  GuiControl, , LibraryLabel,
	GuiControl, , pluginEnabled, 0
	GuiControl, , LibraryPreFix,
	GuiControl, , AddPlugin, Add
} else {
  MsgBox, Fill everything out!`nLibrary: %thisLibrary%`nInclude: %thisInclude%`nLabel: %thisLabel%
}


pluginBeingEdited=
Return
DelPlugin:
Return
SaveSettings:
GUI, submit, NoHide
;GuiControlGet, scriptEditor , , scriptEditor,
;GuiControlGet, useLogging , , useLogging,

IniWrite, %scriptEditor%, %A_ScriptDir%\ScriptEditor.ini, editor, ahk
IniWrite, %useLogging%, %A_ScriptDir%\ScriptEditor.ini, defaults, logging
IniWrite, %editorwindow%, %A_ScriptDir%\ScriptEditor.ini, defaults, editorwindow

var_ScriptDir:="%A_ScriptDir%"
var_CommentChar:="; "
pluginList=%A_ScriptDir%\Includes\Plugins.ahk
IfExist, %pluginList%
  FileDelete, %pluginList%

FileAppend , %var_CommentChar%The plugin function list included into the ScriptEditor`n, %pluginList%

Loop , %countLibrary%
{
	prefixLibrary:=listPreFix%A_INDEX%
	functionLibrary:=listfunctionLibrary%A_INDEX%
	labelLibrary:=listLabel%A_INDEX%
	enableLibrary:=listEnable%A_INDEX%
	includeLibrary:=listIncludes%A_INDEX%

  IniWrite, %prefixLibrary%, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, prefix
	IniWrite, %labelLibrary%, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, label
	IniWrite, %functionLibrary%, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, functions
	IniWrite, %includeLibrary%, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, includes
	IniWrite, %enableLibrary%, %A_ScriptDir%\ScriptEditor.ini, library%A_INDEX%, enabled
	
	if enableLibrary
    FileAppend , #Include %var_ScriptDir%\includes\%functionLibrary%`n, %pluginList%
}

StringSplit, saveIcons, iconsFileTypes , `n, ,
Loop, %saveIcons0%
{
	StringSplit, iconDef, saveIcons%A_INDEX%, ~,
	if (iconDef0=2)
	{
    StringRight, lastChar, iconDef2, 1
    If lastChar=|
      StringTrimRight, iconDef2, iconDef2, 1
	  IniWrite, %iconDef2%, %A_ScriptDir%\ScriptEditor.ini, filetypes, %iconDef1%
 	}
}
MsgBox, 0, %amplScriptName%, Settings saved., 10
Return
AboutPlugin:
 GuiControlGet, thisLibrary , , FunctionFile
 GuiControlGet, thisLabel,,LibraryLabel
	d="
	ahkPath= %d%%A_AhkPath%%d%
	file_Function:= d . directory_FunctionDefinitions . thisLibrary . d . A_SPACE . "\ABOUT"
	RunWait, %ahkPath% %file_Function%,,UseErrorLevel,NewPID
	If ERRORLEVEL=Error
	  MsgBox, There was an error running the script

;MsgBox, 2, Restart ScriptEditor, Did you want to restart the Scipt Editor?,

Return

