;: Title: AMPL Variable Definitions - by scribbly
/*
***********************************************************
START AMPL Definition Header
Version=1.0.0
Prefix=VAR
Label=Variable Definitions
Library=
END AMPL Definition Header
***********************************************************
*/

VAR_Version=
VAR_Prefix=
VAR_Label=
VAR_IncludeSet=
VAR_Library=
ampl_AddFunctionText_Function=AddFunctionText
function_GetFieldNumber=GetFieldNumber
function_GetVariableValue=GetVariableValue
function_DisableCloseButton=DisableCloseButton

run_Direct:=False
if (%0%>0){
	if 1=\ABOUT
	  {
    	VAR_About()
      ExitApp
		}
}  else {
  VAR_Init()
  run_Direct:=True
	VAR_GetFunction( 1 , 10 , 10 )
	return
}


;
; Function: PREFIX_Init
; Description:
;		This function is called when the function plugin is loaded into ScriptEditor.
; Syntax: <PREFIX>_Init()
; Return Value:
;   Success=0
;   Error=1
; Remarks:
;		<PREFIX> must be unique for all AMPL Function Plugins.
;
VAR_Init() {
global
	VAR_Error=1
	VAR_Version=1.0.0
	VAR_Prefix=VAR
	VAR_Label=Variable Definitions
	VAR_IncludeSet:=False
	VAR_Library=

	VAR_Var1_Check=
	VAR_VAR1_Value=
	VAR_Error=0
	VAR_MessageFrame=
	VAR_WinWaitPID_Check=
	VAR_WinWaitPID_Value=
	VAR_WinWaitPID_UpDown=
	VAR_WinWaitCLASS_Check=
	VAR_WinWaitCLASS_Value=
	VAR_WinWaitCLASS_UpDown=
	VAR_WinWaitTITLE_Check=
	VAR_WinWaitTITLE_Value=
	VAR_WinWaitTITLE_UpDown=
	VAR_WinWaitPOSTRUN_Check=
	VAR_WinWaitPOSTRUN_Value=
	VAR_WinWaitPOSTRUN_UpDown=
	VAR_WinTITLE_Check=
	VAR_WinTITLE_Value=
	VAR_WinTITLEMATCHSPEED=
	VAR_WinTITLEMATCH=
	VAR_WinTEXT_Check=
	VAR_WinTEXT_Value=
	VAR_WinEXTITLE_Check=
	VAR_WinEXTITLE_Value=
	VAR_WinEXTEXT_Check=
	VAR_WinEXTEXT_Value=
	VAR_ScriptLOG_Check=
	VAR_ScriptLOG_Value=
	VAR_ERROR_Check=
	VAR_ERROR_Value=
	VAR_CmdWorkingDir_Check=
	VAR_CmdWorkingDir_Value=
	
	ampl_AddFunctionText_Function=AddFunctionText
	function_GetFieldNumber=GetFieldNumber
	function_GetVariableValue=GetVariableValue
	function_DisableCloseButton=DisableCloseButton
	VAR_Error=0
	Return, VAR_Error
}

VAR_GetVersion() {
global VAR_Version
if VAR_Version=
	VAR_Init()
Return, VAR_Version
}

VAR_About() {
global VAR_Version
if VAR_Version=
	VAR_Init()
  MsgBox, This is the AMPL Variables definition.`nVersion: %VAR_Version%
}

;
; Function: PREFIX_GetFunction
; Description:
;		Passes control to the Plugin Library.
; Syntax: PREFIX_GetFunction( WindowNumber , Window_X , Window_Y )
; Parameters:
;		WindowNumber - The Window Number to use if a Gui window is created
;			eg: Gui, %PREFIX_WindowNumber%: Default
;		Window_X - X Position of the AMPL Step window
;			Can be used for positioning a gui window
;		Window_Y - Y Position of the AMPL Step window
;			Can be used for positioning a gui window
; Return Value:
;		None
; Remarks:
;		Put the remarks here (BBCode allowed)
; Related: MyFunc1, MyFunc2, [bbcode]some literal text with commas`, and backticks(``). BBCode allowed.
;		When this parameter is omitted, it defaults to linking every
;		single documentated function in the file.
; Example:
;		VAR_GetFunction(VAR_WindowNumber, VAR_Window_X , VAR_Window_Y) {
;		Gui, %VAR_WindowNumber%: Default
;		Gui, Add, Tab, x6 y30 w400 h250 , Tab1|Tab2
;		Gui, Add, CheckBox, x16 y70 w20 h20 vVAR_Var1_Check,
;		Gui, Add, Text, x46 y70 w170 h20 , Variable One
;		Gui, Add, ComboBox, x226 y70 w100 h20 vVAR_VAR1_Value, Enable|Disable
;		Gui, Add, Edit, x6 y290 w310 h70 ReadOnly,
;		Gui, Add, Button, x326 y290 w80 h30 gVAR_Insert, Insert
;		Gui, Add, Button, x326 y330 w80 h30 gVAR_Cancel, Cancel
;		VAR_Window_X+=5
;		VAR_Window_Y+=30
;		Gui, Show, x%VAR_Window_X% y%VAR_Window_Y% h377 w419, Wait Functions - v%VAR_Version%
;		}
;
VAR_GetFunction( VAR_WindowNumber , VAR_Window_X , VAR_Window_Y ) {
global VAR_Version, VAR_Label,	function_GetFieldNumber,function_GetVariableValue,function_DisableCloseButton
	tmpWinTitle:=%function_GetFieldNumber%(24)
  Gui, %VAR_WindowNumber%: Default
	Gui, Add, Tab, x6 y30 w400 h250 , Window Search Variables|Script Variables

	oldValue:=%function_GetVariableValue%("useWinWaitPID")
	Gui, Add, CheckBox, x16 y70 w20 h20 vVAR_WinWaitPID_Check gVAR_WinWaitPID_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinWaitPID_Check, Wait for Process
	Gui, Add, Edit, xp+210 yp-2 w50 h20 vVAR_WinWaitPID_Value Disabled gVAR_WinWaitPID_Check,%oldValue%
	Gui, Add, UpDown, vVAR_WinWaitPID_UpDown Range0-600, %oldValue%

	oldValue:=%function_GetVariableValue%("useWinWaitCLASS")
	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinWaitCLASS_Check gVAR_WinWaitCLASS_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinWaitCLASS_Check, Wait for Class
	Gui, Add, Edit, xp+210 yp-2 w50 h20 vVAR_WinWaitCLASS_Value Disabled gVAR_WinWaitCLASS_Check,
	Gui, Add, UpDown, vVAR_WinWaitCLASS_UpDown Range0-600, %oldValue%

	oldValue:=%function_GetVariableValue%("useWinWaitTITLE")
	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinWaitTITLE_Check gVAR_WinWaitTITLE_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinWaitTITLE_Check, Wait for Title
	Gui, Add, Edit, xp+210 yp-2 w50 h20 vVAR_WinWaitTITLE_Value Disabled gVAR_WinWaitTITLE_Check,
	Gui, Add, UpDown, vVAR_WinWaitTITLE_UpDown Range0-600, %oldValue%

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinTITLE_Check gVAR_WinTITLE_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinTITLE_Check, Window Title
	Gui, Add, Edit, xp+210 yp-2 w130 h20 vVAR_WinTITLE_Value Disabled gVAR_WinTITLE_Check,%tmpWinTitle%
	Gui, Add, Text, x46 yp+24 w200 h16 Border gVAR_WinTITLE_Check, Title Match Mode
  GUI, Add , DropDownList, xp+210 yp-3 w130 vVAR_WinTITLEMATCH Disabled gVAR_WinTITLE_Check AltSubmit, Match Start|Match Anywhere|Match Exact|Regular Expression
	Gui, Add, Text, x46 yp+24 w200 h16 Border gVAR_WinTITLE_Check, Title Match Speed
  GUI, Add , DropDownList, xp+210 yp-3 w130 vVAR_WinTITLEMATCHSPEED Disabled gVAR_WinTITLE_Check , Fast|Slow

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinTEXT_Check gVAR_WinTEXT_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinTEXT_Check, Window Text
	Gui, Add, Edit, xp+210 yp-2 w130 h20 vVAR_WinTEXT_Value Disabled gVAR_WinTEXT_Check,

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinEXTITLE_Check gVAR_WinEXTITLE_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinEXTITLE_Check, Window Title Exclude
	Gui, Add, Edit, xp+210 yp-2 w130 h20 vVAR_WinEXTITLE_Value Disabled gVAR_WinEXTITLE_Check,

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_WinEXTEXT_Check gVAR_WinEXTEXT_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinEXTEXT_Check, Window Text Exclude
	Gui, Add, Edit, xp+210 yp-2 w130 h20 vVAR_WinEXTEXT_Value Disabled gVAR_WinEXTEXT_Check,

	Gui, Tab, 2
	oldValue:=%function_GetVariableValue%("usewaitPostRun")
	Gui, Add, CheckBox, x16 y70 w20 h20 vVAR_WinWaitPOSTRUN_Check gVAR_WinWaitPOSTRUN_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_WinWaitPOSTRUN_Check, Wait Period after Run
	Gui, Add, Edit, xp+210 yp-2 w50 h20 vVAR_WinWaitPOSTRUN_Value Disabled gVAR_WinWaitPOSTRUN_Check,
	Gui, Add, UpDown, vVAR_WinWaitPOSTRUN_UpDown Range0-600, %oldValue%

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_ScriptLOG_Check gVAR_ScriptLOG_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_ScriptLOG_Check, Script Logging
  GUI, Add , DropDownList, xp+210 yp-3 w130 vVAR_ScriptLOG_Value Disabled gVAR_ScriptLOG_Check AltSubmit, Off|On

	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_ERROR_Check gVAR_ERROR_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_ERROR_Check, AMPL Error Variable
	
	Gui, Add, CheckBox, x16 yp+24 w20 h20 vVAR_CmdWorkingDir_Check gVAR_CmdWorkingDir_Check,
	Gui, Add, Text, x46 yp+1 w200 h16 Border gVAR_CmdWorkingDir_Check, Working Directory of Command
	Gui, Add, Edit, xp+210 yp-2 w130 h20 vVAR_CmdWorkingDir_Value Disabled gVAR_CmdWorkingDir_Check,
	
	Gui, Tab
	Gui, Add, Edit, x6 y290 w310 h70 ReadOnly vVAR_MessageFrame,
	Gui, Add, Button, x326 y290 w80 h30 gVAR_Insert, Insert
	Gui, Add, Button, x326 y330 w80 h30 gVAR_Cancel, Cancel
	VAR_Window_X+=5
	VAR_Window_Y+=30
	Gui, Show, x%VAR_Window_X% y%VAR_Window_Y% h377 w419, %VAR_Label% - v%VAR_Version%
	%function_DisableCloseButton%()
}

VAR_Insert:
GUI, Submit, NoHide
return_Value=
;MsgBox, Check: %VAR_WinWaitPID_Check%`nValue: %VAR_WinWaitPID_Value%
if (VAR_WinWaitPID_Check and VAR_WinWaitPID_Value!="")
		return_Value:="var_WinWaitPIDSeconds=" . VAR_WinWaitPID_Value . "`n"
if (VAR_WinWaitCLASS_Check and VAR_WinWaitCLASS_Value!="")
		return_Value.="var_WinWaitCLASSSeconds=" . VAR_WinWaitCLASS_Value . "`n"
if (VAR_WinWaitTITLE_Check and VAR_WinWaitTITLE_Value!="")
		return_Value.="var_WinWaitTITLESeconds=" . VAR_WinWaitTITLE_Value . "`n"
if (VAR_WinWaitPOSTRUN_Check and VAR_WinWaitPOSTRUN_Value!="")
		return_Value.="var_waitPostRunMilliseconds=" . VAR_WinWaitPOSTRUN_Value . "`n"
if (VAR_WinTITLE_Check and VAR_WinTITLE_Value!="") {
		return_Value.="win_title=" . VAR_WinTITLE_Value . "`n"
		if VAR_WinTITLEMATCH Between 1 and 3
			return_Value.="SetTitleMatchMode, " . VAR_WinTITLEMATCH . "`n"
		if VAR_WinTITLEMATCH =4
			return_Value.="SetTitleMatchMode, RegEx`n"
		if VAR_WinTITLEMATCHSPEED !=
			return_Value.="SetTitleMatchMode, " . VAR_WinTITLEMATCHSPEED . "`n"
}
if (VAR_WinTEXT_Check and VAR_WinTEXT_Value!="")
		return_Value.="win_text=" . VAR_WinTEXT_Value . "`n"
if (VAR_WinEXTEXT_Check and VAR_WinEXTEXT_Value!="")
		return_Value.="win_extext=" . VAR_WinEXTEXT_Value . "`n"
if (VAR_WinEXTITLE_Check and VAR_WinEXTITLE_Value!="")
		return_Value.="win_extitle=" . VAR_WinEXTITLE_Value . "`n"
if (VAR_ScriptLOG_Check and VAR_ScriptLOG_Value>0)
		return_Value.="DoLogToFile=" . VAR_ScriptLOG_Value-1 . "`n"
if (VAR_ERROR_Check )
		return_Value.="ampl_ERROR+=0`n"
if (VAR_CmdWorkingDir_Check)
		return_Value.="cmd_WorkingDirectory=" . VAR_CmdWorkingDir_Value . "`n"
Gui, Destroy
%ampl_AddFunctionText_Function%(VAR_Prefix , return_Value)
Return


VAR_Cancel:
Gui, Destroy
%ampl_AddFunctionText_Function%(VAR_Prefix , "")
Return

VAR_IncludeDirective() {
	global VAR_IncludeSet, VAR_Library

	return_Value=
	newLine=`n
  ;MsgBox, IncludeSet: %VAR_IncludeSet%
	if !VAR_IncludeSet
	{
	  return_Value:= VAR_Library
	  VAR_IncludeSet:=True
	}
  Return , return_Value
}

/*
**
** WINDOW SUB-ROUTINES
**
*/

VAR_WinWaitPID_Check:
GuiControlGet, VAR_check_WinWaitPID, , VAR_WinWaitPID_Check,
GuiControl, Enable%VAR_check_WinWaitPID%, VAR_WinWaitPID_Value,
GuiControl, , VAR_MessageFrame, The number of seconds to wait for the window generated by the Process ID.
if VAR_check_WinWaitPID
  GuiControl, Focus, VAR_WinWaitPID_Value
Return
VAR_WinWaitCLASS_Check:
GuiControlGet, VAR_check_WinWaitCLASS, , VAR_WinWaitCLASS_Check,
GuiControl, Enable%VAR_check_WinWaitCLASS%, VAR_WinWaitCLASS_Value,
GuiControl, , VAR_MessageFrame, The number of seconds to wait for the window of a certain Class.
if VAR_check_WinWaitCLASS
  GuiControl, Focus, VAR_WinWaitCLASS_Value
Return
VAR_WinWaitTITLE_Check:
GuiControlGet, VAR_check_WinWaitTITLE, , VAR_WinWaitTITLE_Check,
GuiControl, Enable%VAR_check_WinWaitTITLE%, VAR_WinWaitTITLE_Value,
GuiControl, , VAR_MessageFrame, The number of seconds to wait for the window of a certain Title.
if VAR_check_WinWaitTITLE
  GuiControl, Focus, VAR_WinWaitTITLE_Value
Return
VAR_WinWaitPOSTRUN_Check:
GuiControlGet, VAR_check_WinWaitPOSTRUN, , VAR_WinWaitPOSTRUN_Check,
GuiControl, Enable%VAR_check_WinWaitPOSTRUN%, VAR_WinWaitPOSTRUN_Value,
GuiControl, , VAR_MessageFrame, The number of milliseconds to wait after the command has been run. 1000 is one second.
Return
VAR_WinTITLE_Check:
GuiControlGet, VAR_check_WinTITLE, , VAR_WinTITLE_Check,
GuiControl, Enable%VAR_check_WinTITLE%, VAR_WinTITLE_Value,
GuiControl, Enable%VAR_check_WinTITLE%, VAR_WinTITLEMATCHSPEED,
GuiControl, Enable%VAR_check_WinTITLE%, VAR_WinTITLEMATCH,
GuiControl, , VAR_MessageFrame, The text to search for in window titles.`nTitle Match Mode defines where to look.`nTitle Match Speed defines the behaviour.
Return
VAR_WinTEXT_Check:
GuiControlGet, VAR_check_WinTEXT, , VAR_WinTEXT_Check,
GuiControl, Enable%VAR_check_WinTEXT%, VAR_WinTEXT_Value,
GuiControl, , VAR_MessageFrame, The text to search for in window's text.
Return
VAR_WinEXTITLE_Check:
GuiControlGet, VAR_check_WinEXTITLE, , VAR_WinEXTITLE_Check,
GuiControl, Enable%VAR_check_WinEXTITLE%, VAR_WinEXTITLE_Value,
GuiControl, , VAR_MessageFrame, The text to exclude in window titles.
Return
VAR_WinEXTEXT_Check:
GuiControlGet, VAR_check_WinEXTEXT, , VAR_WinEXTEXT_Check,
GuiControl, Enable%VAR_check_WinEXTEXT%, VAR_WinEXTEXT_Value,
GuiControl, , VAR_MessageFrame, The text to search for in window's text.
Return
VAR_ScriptLOG_Check:
GuiControlGet, VAR_check_ScriptLOG, , VAR_ScriptLOG_Check,
GuiControl, Enable%VAR_check_ScriptLOG%, VAR_ScriptLOG_Value,
GuiControl, , VAR_MessageFrame, Logging records the script execution commands and results. It can be useful for debugging a complex script.
Return
VAR_ERROR_Check:
GuiControlGet, VAR_check_ERROR, , VAR_ERROR_Check,
;GuiControl, Enable%VAR_check_ERROR%, VAR_ERROR_Value,
GuiControl, , VAR_MessageFrame, The Error variable can be modified. The Action Section can use the Error Level: Success=0, Error > 0 and < 100, Failure >= 100
Return
VAR_CmdWorkingDir_Check:
GuiControlGet, VAR_check_CmdWorkingDir, , VAR_CmdWorkingDir_Check,
GuiControl, Enable%VAR_check_CmdWorkingDir%, VAR_CmdWorkingDir_Value
GuiControl,, VAR_MessageFrame, The Command's working directory can be manually edited; it is automatically added when running a shortcut link.
Return
