thisScript_Name=AMPL Script Editor Functions
version_ScriptEditorFunctions=0.1.5
thisScriptVersionDate=2009.10.06
thisScript_AuthorName=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

/*
**********************************************************************************
** 	Version History
**********************************************************************************
**  0.1.x
**    todo add date strings for versions
**    todo add script_CreateDate
**    todo add script_ModifiedDate
**    todo add Error catch to code After if ampl_WinID="" (default?="If ampl_winID!={}")
**  0.1.5 2009.10.06
**    ! Fixed LoadIcon issue when no command is used
**    + Added ExitApp to end of Scripts to force closure
**  0.1.4 2009.09.14
**    + DisableCloseButton & RedrawSysMenu Functions added
**    ! Fixed problem when varible value contained "="
**  0.1.3 2009.07.02
**		+ Added Function Update Field()
**  0.1.2 2009.06.25
**    ^ Improvements to version writing
**  0.1.1 2009.06.22
**    ! Fixed cmd on load: adds drive if missing
**    ! Fixed  (useTempLogging=True)
**    ^ Added SetTitleMatchMode defaults to WriteFile
**  0.1.0 2009.06.14 First Beta Release
**
**********************************************************************************
*/

if amplDirectory=
	SplitPath, A_SCRIPTDIR, , amplDirectory, , ,
SplitPath, A_AhkPath, , ahkDirectory, , ,

search_VersionString:="thisScript_Version="
if version_ScriptEditor=
{
	version_ScriptEditor:="Not Installed"
	search_ScriptPath := amplDirectory . "\ScriptEditor\ScriptEditor.ahk"
  IfExist, %search_ScriptPath%
  {
	  Loop, Read, %search_ScriptPath%
	  {
      IfInString, A_LOOPREADLINE, %search_VersionString%
			{
        StringSplit, versionString, A_LOOPREADLINE , =,
        version_ScriptEditor:=versionString2
        Break
			}
	  }
	}
}
if version_ScriptUpdate=
{
	version_ScriptUpdate:="Not Installed"
	search_ScriptPath := amplDirectory . "\ScriptUpdate.ahk"
  IfExist, %search_ScriptPath%
  {
	  Loop, Read, %search_ScriptPath%
	  {
      IfInString, A_LOOPREADLINE, %search_VersionString%
			{
        StringSplit, versionString, A_LOOPREADLINE , =,
        version_ScriptUpdate:=versionString2
        Break
			}
	  }
	}
}
if version_ScriptShortCutter=
{
	version_ScriptShortCutter:="Not Installed"
	search_ScriptPath := amplDirectory . "\CreateShortCut.ahk"
  IfExist, %search_ScriptPath%
  {
	  Loop, Read, %search_ScriptPath%
	  {
      IfInString, A_LOOPREADLINE, %search_VersionString%
			{
        StringSplit, versionString, A_LOOPREADLINE , =,
        version_ScriptShortCutter:=versionString2
        Break
			}
	  }
	}
}
if version_Recorder=
{
	version_Recorder:="Not Installed"
	search_ScriptPath := amplDirectory . "\ScriptEditor\AMPLRecorder.ahk"
  IfExist, %search_ScriptPath%
  {
	  Loop, Read, %search_ScriptPath%
	  {
      IfInString, A_LOOPREADLINE, %search_VersionString%
			{
        StringSplit, versionString, A_LOOPREADLINE , =,
        version_Recorder:=versionString2
        Break
			}
	  }
	}
}
; Get the Includes Version
version_AMPL_Includes_Installed:="Not Installed"
version_AMPL_Package:="Not Installed"
search_ScriptPath := amplDirectory . "\scripts\includes\AMPL_Includes.ahk"
IfExist, %search_ScriptPath%
{
  Loop, Read, %search_ScriptPath%
  {
    IfInString, A_LOOPREADLINE, version_AMPL_Includes=
		{
      StringSplit, versionString, A_LOOPREADLINE , =,
      version_AMPL_Includes_Installed:=versionString2
		}
    IfInString, A_LOOPREADLINE, version_AMPL_Package=
		{
      StringSplit, versionString, A_LOOPREADLINE , =,
      version_AMPL_Package:=versionString2
		}
		if (version_AMPL_Package!=Not Installed and version_AMPL_Includes_Installed!=Not Installed)
		  break
  }
}

; Script Step Fields
MoveDo:=0
#MoveDo:=9
MoveX=0
#MoveX:=10
MoveY=0
#MoveY:=11
SizeDo=0
#SizeDo:=12
SizeW=0
#SizeW:=13
SizeH=0
#SizeH:=14
delayBefore=0
#delayBefore:=3
delayAfter=0
#delayAfter:=8
minmaxAfter=0
#minmaxAfter:=15
stepTitle=
#stepTitle:=1
cmdPath=
#cmdPath:=4
fileName=
#fileName:=2
cmdParameter=
#cmdParameter:=5
cmdProcess=
#cmdProcess:=7
codeBefore=
#codeBefore:=22
cmdRunWait=0
#cmdRunWait:=6
codeAfter=
#codeAfter:=23
waitFor=
#waitFor:=16
waitForTimeOut=0
#waitForTimeOut:=17
actionWhat=0
#actionWhat:=19
actionWhen=0
#actionWhen:=18
actionForce=0
#actionForce:=20
actionTimeOut=0
#actionTimeOut:=21
winTitle=
#winTitle:=24
winClass=
#winClass:=25
iconListViewNumber=1
#iconListViewNumber:=26
iconPath=
#iconPath:=27
cmdNone=0
#cmdNone:=28
msgShow=0
#msgShow:=29
msgTimeOut=0
#msgTimeOut:=30

minmaxAfter1=0
minmaxAfter2=0
minmaxAfter3=0
usePosition=0
useMonitor=0
;xwinTitle=
winTitle=
;xwinClass=
winClass=
GetFileParameter=
LargeIcon=
cmdOriginal=
ForceLabel=

characterSeparator=~      ; separates fields in the command Object
commandList=              ; the command steps

LoadFile(fileToLoad){
	Global characterSeparator, commandList, iconsFileTypes, ImageListID, script_Version, windowMainCreated
 ; Load file here...
	 commentCharacter=;
	 commentStart:="/*"
	 commentEnd:="*/"
   SplitPath, fileToLoad, , , , OutNameNoExt, scriptDrive

   if windowMainCreated=1
   	GuiControl, , MessageFrame, Loading: %OutNameNoExt%
   ;MsgBox, Reading %fileToLoad% into a variable
   FileRead, scriptContents, %fileToLoad%
   lastPos=0
   countSteps=0
   Loop
   {
   	  lastPos:=InStr(scriptContents, "; BEGIN script Step #", false, lastPos+1)
   	  if lastPos=0
        Break
			if lastPos>0
			  countSteps+=1
   }
   if windowMainCreated=1
   	GuiControl, Show, ProgressBar
   inCodeBefore:=false
   inCodeAfter:=false
   ;MsgBox, Counted %countSteps% steps.
   Loop, Parse, scriptContents,`n,`r
   {
     scriptStepNumber=
     commentString=
     scriptVariableName=
     scriptVariableValue=
   	if (SubStr(A_LoopField, 1, 1)=commentCharacter)
   	{
     StringReplace, commentString, A_LoopField, `;%A_SPACE%, ~
     StringReplace, commentString, commentString, %A_SPACE%#, ~
     StringSplit, commentString, commentString, ~
     if commentString0>2
				scriptStepNumber = %commentString3%
		 if commentString0>1
		    commentString=%commentString2%
     ;MsgBox, Comment: %commentString%`nStep Number: %scriptStepNumber%
		} else {
      StringSplit, scriptVariable,A_LoopField,=
      ;msgbox, Source: [%A_LoopField%]`nParts: %scriptVariable0%
      if (scriptVariable0>0)
         {
					scriptVariableName = %scriptVariable1%
					; Just in-case the variable has an '=' we'll put it back together...
          Loop , %scriptVariable0%
          {
              If A_INDEX = 1
                  continue
                  
						scriptVariableValue .= scriptVariable%A_INDEX% . "="
          }
          StringLeft, scriptVariableValue, scriptVariableValue, StrLen(scriptVariableValue)-1
		      ;msgbox, Source: [%A_LoopField%]`nParts: %scriptVariable0%`n[%scriptVariable1%]`n[%scriptVariable2%]`n%scriptVariableValue%
				 }
		}
		if commentString=END codeBefore
		   inCodeBefore:=false
		if commentString=END codeAfter
		   inCodeAfter:=false
		if (inCodeBefore=true)
		   editcodeBefore=%editCodeBefore%%A_LoopField%`n
		if (inCodeAfter=true)
		   editcodeAfter=%editcodeAfter%%A_LoopField%`n
		if commentString=START codeBefore
		   {
		    editcodeBefore=
				inCodeBefore:=true
				}
		if commentString=START codeAfter
		   {
				inCodeAfter:=true
		    editcodeAfter=
				}
		if scriptVariableName=script_Version
		   script_Version = %scriptVariableValue%
		if scriptVariableName=step_title
		   editTitle = %scriptVariableValue%
		if scriptVariableName=file_name
		   editFileName = %scriptVariableValue%
		if scriptVariableName=cmd_delayBefore
		   editDelayBefore = %scriptVariableValue%
		if (scriptVariableName="cmd_fullPath")
		{
		   editCmdPath = %scriptVariableValue%
       ;MsgBox, Variable=%scriptVariableName%`ncmdPath = %scriptVariableValue%
		}
		if scriptVariableName=cmd_parameters
		   editCmdParameters = %scriptVariableValue%
		if scriptVariableName=cmd_processName
		   editcmdProcess = %scriptVariableValue%
		if scriptVariableName=cmd_delayAfter
		   editDelayAfter = %scriptVariableValue%
		if scriptVariableName=win_moveDo
		   editMoveDo = %scriptVariableValue%
		if scriptVariableName=win_moveX
		   editMoveX = %scriptVariableValue%
		if scriptVariableName=win_moveY
		   editMoveY = %scriptVariableValue%
		if scriptVariableName=win_sizeDo
		   editSizeDo = %scriptVariableValue%
		if scriptVariableName=win_sizeW
		   editSizeW = %scriptVariableValue%
		if scriptVariableName=win_sizeH
		   editSizeH = %scriptVariableValue%
		if scriptVariableName=win_minMax
		   editMinmaxAfter = %scriptVariableValue%
		if scriptVariableName=step_waitFor
		   editwaitFor = %scriptVariableValue%
		if scriptVariableName=step_waitForTimeOut
		   editwaitForTimeOut = %scriptVariableValue%
		if scriptVariableName=win_title
		   editWinTitle = %scriptVariableValue%
		if scriptVariableName=win_class
		   editWinClass = %scriptVariableValue%
		if scriptVariableName=step_actionWhen
			 editActionWhen = %scriptVariableValue%
		if scriptVariableName=step_actionWhat
			 editActionWhat = %scriptVariableValue%
		if scriptVariableName=step_actionForce
			 editActionForce = %scriptVariableValue%
		if scriptVariableName=step_actionTimeOut
			 editActionTimeOut = %scriptVariableValue%
	  if scriptVariableName=cmd_runWait
			 editcmdRunWait = %scriptVariableValue%
	  if scriptVariableName=cmd_noCommand
	    {
			 editCmdNone = %scriptVariableValue%
			 ;msgbox, editCmdNone = %scriptVariableValue%
			 }
	  if scriptVariableName=msg_show
	  {
			 editmsgShow = %scriptVariableValue%
			 ;msgbox, msgShow: %editmsgShow%`n%scriptVariableValue%
	  }
	  if scriptVariableName=msg_timeout
	  {
			 editmsgTimeOut = %scriptVariableValue%
			 ;msgbox, msgShow: %editmsgShow%`n%scriptVariableValue%
	  }
		if commentString=End Script Step
		{
			 ; Load Icon image
			 ;if windowMainCreated=1
			 ;{
			   iconListViewNumber:=LoadIcon(editCmdPath)
				 iconPath=%ERRORLEVEL%
			 ;}
			 ; Trim extra CharageReturn
       StringTrimRight, editcodeAfter, editcodeAfter, 1
       StringTrimRight, editcodeBefore, editcodeBefore, 1
       if SubStr(editCmdPath, 2, 1) <> ":" && StrLen(editCmdPath) > 0
				{
			    ; editCmdPath is on same drive as script!
				  editCmdPath = %scriptDrive%\%editCmdPath%
				}
			 step:=CompileCommandObject(editTitle , editFileName , editDelayBefore , editCmdPath , editCmdParameters , editcmdRunWait , editcmdProcess , editDelayAfter , editMoveDo , editMoveX , editMoveY , editSizeDo , editSizeW , editSizeH , editMinmaxAfter , editwaitFor , editwaitForTimeOut , editActionWhen , editActionWhat , editActionForce , editActionTimeOut , editcodeBefore, editcodeAfter , editWinTitle , editWinClass , iconListViewNumber , iconPath , editCmdNone, editmsgShow, editmsgTimeOut)
       ;MsgBox, Step: %step%
			 commandList = %commandList%%step%`n
			 stepsLoaded+=1
			 progressSoFar:=(stepsLoaded/countSteps)*100
       ;Sleep, 2000
			 if windowMainCreated=1
       	GuiControl, , ProgressBar, %progressSoFar%
			 ;msgbox, Loaded Step: %step%
		}
	}
  ;Sleep, 2000
	if windowMainCreated=1
 		GuiControl, , MessageFrame, Loaded: %OutNameNoExt%
  ;MsgBox, Loaded: %OutNameNoExt%
  scriptContents= ; Free the Memory
  if (stepsLoaded=1 and editCmdNone=1)
  	ERRORLEVEL=NoCmd
	else
	  ERRORLEVEL=YesCmd
  Return , stepsLoaded
}

WriteFiles(scriptPath , iniPath , includePath, useTempLogging){
Global characterSeparator, commandList,script_Version,ScriptVersionDate,thisScript_AuthorName,amplWebSite, script_Version, saveScript,#MoveDo,#MoveX,#MoveY,#SizeDo,#SizeW,#SizeH,#delayBefore,#delayAfter,#minmaxAfter,#stepTitle,#cmdPath,#fileName,#cmdParameter,#cmdProcess,#codeBefore,#cmdRunWait,#codeAfter,#waitFor,#waitForTimeOut,#actionWhat,#actionWhen,#actionForce,#actionTimeOut,#winTitle,#winClass,#iconListViewNumber,#iconPath,#cmdNone,#msgShow,#msgTimeOut,version_AMPL_Includes_Installed,windowMainCreated,useLogging,usewaitPostRun,useWinWaitPID,useWinWaitCLASS,useWinWaitTITLE,version_AMPL_Package,version_ScriptEditor,thisScript_Name,name_Script,version_Script, thisScript_Version

SplitPath, scriptPath, , , , , scriptDrive

; Increment the scipt version
script_Version+=1
useTempMode:=False
if useLogging=1
	useLoggingNow=true
else
	useLoggingNow=false
if (useTempLogging=True)
	{
		useLoggingNow=True
		useTempMode:=True
 	}
	
; Get the dateTime
FormatTime, dateTimeNow, , yyyy.MM.dd H:mm:ss
  FileAppend,
	(
/*
** Script Generated by AutoHotKey Multiple Programme Launcher [AMPL] Script Editor
** AMPL Version: %version_AMPL_Package%
** AMPL ScriptEditor: %version_ScriptEditor%
** AMPL ScriptEditor Functions: %version_ScriptEditorFunctions%
** AMPL created by: %thisScript_AuthorName%
** WebSite: %amplWebSite%
*/

; This version written by %name_Script% (%version_Script%) on %dateTimeNow%
script_Version=%script_Version%
; This is used to ensure that updates to the Includes File are caught
version_AMPL_Includes_Used=%version_AMPL_Includes_Installed%
; AMPL Code is included with supplied script: DO NOT EDIT!
#Include %includePath%
DoLogToFile:=%useLoggingNow%
ampl_TestMode:=%useTempMode%

	), %scriptPath%
	
	totalSteps:=0
	Loop, Parse, commandList, `n
  {
    if StrLen(A_LoopField) = 0
      Break
    totalSteps+=1
	}

  Loop, Parse, commandList, `n
  {
    if StrLen(A_LoopField) = 0
      Break

    ;MsgBox, [%A_LoopField%]
    StringSplit, commandArray, A_LoopField, %characterSeparator%

    ; If there is no Run Command then there is no sense going on...
    if StrLen(commandArray%#cmdPath%) = 0 and commandArray%#cmdNone%=0
      Break
    if windowMainCreated=1
    {
      ;Sleep, 2000
    	GuiControl, , MessageFrame, Writing: %commandArray1% (Step %A_INDEX%)
    	updateProgress:= (A_INDEX / totalSteps) * 100
    	GuiControl, , ProgressBar, %updateProgress%
    }
    SplitPath, commandArray%#cmdPath%, , , , , fileDrive

		; If the script is on the same Drive as the fileToRun then the Drive is removed to indicate that the path is relative
		; This will allow FARR to be run from a USB Drive from different computers with different letters assigned
    if scriptDrive = %fileDrive%
        commandArray%#cmdPath% := SubStr(commandArray%#cmdPath%, 4 )

		stepName = Step `#%A_INDEX%`
		s_t:=commandArray%#stepTitle%
		f_n:=commandArray%#fileName%
		d_b:=commandArray%#delayBefore%
		d_a:=commandArray%#delayAfter%
		c_fp:=commandArray%#cmdPath%
		c_p:=commandArray%#cmdParameter%
		c_rw:=commandArray%#cmdRunWait%
		c_pn:=commandArray%#cmdProcess%
		c_n:=commandArray%#cmdNone%
		m_d:=commandArray%#MoveDo%
		m_x:=commandArray%#MoveX%
		m_y:=commandArray%#MoveY%
		s_d:=commandArray%#SizeDo%
		s_w:=commandArray%#SizeW%
		s_h:=commandArray%#SizeH%
		w_m:=commandArray%#minmaxAfter%
		w_wf:=commandArray%#waitFor%
		w_wt:=commandArray%#waitForTimeOut%
		a_t:=commandArray%#actionWhen%
		a_w:=commandArray%#actionWhat%
		a_f:=commandArray%#actionForce%
		a_to:=commandArray%#actionTimeOut%
		w_t:=commandArray%#winTitle%
		w_c:=commandArray%#winClass%
		p_b:=commandArray%#codeBefore%
		p_a:=commandArray%#codeAfter%
		s_ms:=commandArray%#msgShow%
		s_mt:=commandArray%#msgTimeOut%

  	StringReplace, p_a, p_a, |, `n, All
  	StringReplace, p_b, p_b, |, `n, All


    FileAppend,
    (
; BEGIN script %stepName%
; Step Variables
step_title=%s_t%
file_name=%f_n%
cmd_delayBefore=%d_b%
cmd_fullPath=%c_fp%
cmd_parameters=%c_p%
cmd_runWait=%c_rw%
cmd_processName=%c_pn%
cmd_noCommand=%c_n%
cmd_delayAfter=%d_a%
win_moveDo=%m_d%
win_moveX=%m_x%
win_moveY=%m_y%
win_sizeDo=%s_d%
win_sizeW=%s_w%
win_sizeH=%s_h%
win_minMax=%w_m%
step_waitFor=%w_wf%
step_waitForTimeOut=%w_wt%
step_actionWhen=%a_t%
step_actionWhat=%a_w%
step_actionForce=%a_f%
step_actionTimeOut=%a_to%
win_title=%w_t%
win_text=
win_exTitle=
win_exText=
win_class=%w_c%
msg_show=%s_ms%
msg_timeout=%s_mt%
;Default Variables
var_waitPostRunMilliseconds=%usewaitPostRun%
var_WinWaitPIDSeconds=%useWinWaitPID%
var_WinWaitCLASSSeconds=%useWinWaitCLASS%
var_WinWaitTITLESeconds=%useWinWaitTITLE%
cmd_WorkingDirectory=
;AHK Default Settings
SetTitleMatchMode, 1
SetTitleMatchMode, Fast

ampl_ERROR=0

; Start codeBefore
%p_b%
; End codeBefore
ampl_procID=
ampl_WinID=

if cmd_noCommand=0
{
	return_IDs := ampl_ProcessCommand(step_title, file_name , cmd_delayBefore , cmd_fullPath, cmd_parameters, cmd_WorkingDirectory, cmd_runWait , cmd_processName , cmd_delayAfter , win_moveDo , win_moveX , win_moveY , win_sizeDo , win_sizeW , win_sizeH, win_minMax, win_title, win_class, win_text, win_exTitle, win_exText, msg_show, msg_timeout, var_waitPostRunMilliseconds, var_WinWaitPIDSeconds, var_WinWaitCLASSSeconds, var_WinWaitTITLESeconds)
	process_ERROR:=ERRORLEVEL
	if(process_ERROR=101)
	{
	  if msg_show=1
	  	MsgBox,0,%step_title%, An error occured running %commandArray4%, %msg_timeout%
	} else if(process_ERROR=100)
	{
	  if msg_show=1
			msgbox,0,%step_title%, The Command Path has not been set correctly, %msg_timeout%
	} else
	{
		StringSplit, return_ID, return_IDs,~
		ampl_procID:=return_ID1
		ampl_WinID:=return_ID2
	}
	ampl_ERROR+=process_ERROR
}
; Start codeAfter
%p_a%
; End codeAfter

ampl_WaitForWindow( ampl_WinID , step_waitForTimeOut , step_waitFor )
ampl_ERROR+=ERRORLEVEL
ampl_FinalAction( step_actionWhen, ampl_ERROR , step_actionWhat , step_actionForce , step_actionTimeOut , ampl_WinID )
; END script %stepName%

    ), %scriptPath%

	blank=
	if windowMainCreated=1
  	IniWrite, %blank% , %iniPath%, %f_n%, AltLocation1

}
  FileAppend,
	(
; Close the Script
ExitApp
	), %scriptPath%

}

CompileCommandObject( title , fileName , delayBefore , cmdPath , cmdParameter, cmdRunWait, procedureName , postd , doMove , moveX , moveY , doSize , sizeW , sizeH , minmaxAfter , waitFor , waitForTimeOut , actionWhen , actionWhat , actionForce , actionTimeOut , codeBefore, codeAfter , winTitle , winClass , iconNumber , iconLarge, cmdNone , showMessages, showMsgTimeOut){
	Global characterSeparator
	;Title;beforeDelay;Cmd;ProcessName;PostDelay;MoveDo;MoveX;MoveY;SizeDo;SizeW;SizeH;PostProcess;codeAfter
	; Replace linefeeds with pipes
  StringReplace, codeBefore, codeBefore,`n,|, All
  StringReplace, codeAfter, codeAfter,`n,|, All
;  MsgBox, Icon#: %iconNumber%

  Return, title                             	; 1
    . characterSeparator . fileName           ; 2
		. characterSeparator . delayBefore        ; 3
		. characterSeparator . cmdPath            ; 4
		. characterSeparator . cmdParameter       ; 5
		. characterSeparator . cmdRunWait		      ; 6
		. characterSeparator . procedureName      ; 7
		. characterSeparator . postd              ; 8
		. characterSeparator . doMove             ; 9
		. characterSeparator . moveX              ; 10
		. characterSeparator . moveY              ; 11
		. characterSeparator . doSize             ; 12
		. characterSeparator . sizeW              ; 13
		. characterSeparator . sizeH              ; 14
		. characterSeparator . minmaxAfter        ; 15
		. characterSeparator . waitFor            ; 16
		. characterSeparator . waitForTimeOut     ; 17
		. characterSeparator . actionWhen		      ; 18
		. characterSeparator . actionWhat     		; 19
		. characterSeparator . actionForce     		; 20
		. characterSeparator . actionTimeOut  		; 21
		. characterSeparator . codeBefore         ; 22
		. characterSeparator . codeAfter          ; 23
		. characterSeparator . winTitle           ; 24
		. characterSeparator . winClass           ; 25
		. characterSeparator . iconNumber         ; 26
		. characterSeparator . iconLarge          ; 27
		. characterSeparator . cmdNone          	; 28
		. characterSeparator . showMessages      	; 29
		. characterSeparator . showMsgTimeOut			; 30
}

LoadIcon(filePath){
 Global iconsFileTypes, ImageListID
  SplitPath, filePath, , , thisExtension, , thisDrive
	; Paths on the same drive are stored without Drive
  SplitPath, A_SCRIPTFULLPATH,,,,,s_Drive
  if (thisDrive="" && filePath!="")
    filePath:=s_Drive . "\" . filePath
	;msgbox, %filePath%`nDrive: [%thisDrive%]`nScriptDrive: %s_Drive%
	if filePath!=
	{
	if thisExtension!=
  	thisExtension=|%thisExtension%|
	else
	  thisExtension=|folder|
	}
	getIcon=
	; Loop through the extensions that have icons
	if thisExtension!=
	{
	  Loop, Parse, iconsFileTypes, `n
	  {
	  	if InStr(A_LoopField, thisExtension)>0        ; if the extension is in the list..
	  	  {
	  	    ; Each loop = graphic.ico|jpg|png|bmp
	  	    ; Grab the leaf as the filename to use
	        StringSplit, foundExt, A_LoopField, |
					getIcon = %foundExt1%
	        Break
				}
	  }
  }
  if getIcon!=
    {
    	;gui, 2: add, Picture, x6 y3 w32 h32 vLargeIcon, %amplDirectory%\ScriptCreator\filetypes\%getIcon%
    	iconPath=%A_ScriptDir%\icons\filetypes\%getIcon%
      GuiControl,, LargeIcon,*w32 *h32 %iconPath%
	  	iconID:=IL_Add(ImageListID, iconPath )
		}
	else
	  {
  	;Gui, 2: Add, Picture, x6 y3 w32 h32 vLargeIcon, %fileToRun%
  	if filePath=
  	  filePath=%A_ScriptDir%\icons\Script_Edit.ico
  	GuiControl,, LargeIcon,*w32 *h32 %filePath%
	  iconID:=IL_Add(ImageListID, filePath )
	  iconPath=%filePath%
  	}

	if iconID=0
	  iconListViewNumber=1
	else
	  iconListViewNumber=%iconID%

	ERRORLEVEL=%iconPath%
	Return iconListViewNumber
}

GetField(string_Source,field_Number,string_FieldSeparater) {
	result=
  Loop, Parse, string_Source, %string_FieldSeparater%,
  {
  	if (A_INDEX=field_Number)
  	{
			result:=A_LOOPFIELD
      Break
		}
  }
  if result=
		ERRORLEVEL=1
	else
	  ERRORLEVEL=0

  Return, result
}

UpdateField(string_Source,field_Number,field_Value, string_FieldSeparater) {
	result=
  Loop, Parse, string_Source, %string_FieldSeparater%,
  {
  	if (A_INDEX=field_Number)
  	{
			result.= field_Value . string_FieldSeparater
		} else
		{
			result.= A_LoopField . string_FieldSeparater
		}
  }

  StringTrimRight, result, result, 1
  if result=
		ERRORLEVEL=1
	else
	  ERRORLEVEL=0
  Return, result	

}
/*
How to Disable ( Grey-out ) the Close Button?
Author: SKAN
http://www.autohotkey.com/forum/viewtopic.php?p=62506#62506
*/

DisableCloseButton(hWnd="") {
 If hWnd=
    hWnd:=WinExist("A")
 hSysMenu:=DllCall("GetSystemMenu","Int",hWnd,"Int",FALSE)
 nCnt:=DllCall("GetMenuItemCount","Int",hSysMenu)
 DllCall("RemoveMenu","Int",hSysMenu,"UInt",nCnt-1,"Uint","0x400")
 DllCall("RemoveMenu","Int",hSysMenu,"UInt",nCnt-2,"Uint","0x400")
 DllCall("DrawMenuBar","Int",hWnd)
Return ""
}
RedrawSysMenu(hWnd="") {
 If hWnd=
    hWnd:=WinExist("A")
 DllCall("GetSystemMenu","Int",hWnd,"Int",TRUE)
 DllCall("DrawMenuBar","Int",hWnd)
Return ""
}
