; AMPL Script Updater
#NoEnv
#SingleInstance force

thisScript_Name=AMPL Script Updater
title_ScriptUpdate:=thisScript_Name
thisScript_Version=0.1.2
version_ScriptUpdate:=thisScript_Version
thisScript_VersionDate=2009.10.12
thisScript_AuthorName=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

/* 	
**********************************************************
**  AMPL Script Updater
**********************************************************
**
**********************************************************
** 	Version History
**********************************************************
**  0.1.2 2009.10.12
**    ! Fixed script name & version strings (were getting mixed up with included variables)
**  0.1.1 2009.06.25
**    ^ Cleaned up version variables across the scripts
**  0.1.0 2009.06.14 First Beta Release
**
*/

amplDirectory:=A_ScriptDir
IniRead, useLogging, %A_ScriptDir%\ScriptEditor\ScriptEditor.ini, defaults, logging, 0
IniRead, usewaitPostRun, %A_ScriptDir%\ScriptEditor\ScriptEditor.ini, defaults, waitPostRun, 0
IniRead, useWinWaitPID, %A_ScriptDir%\ScriptEditor\ScriptEditor.ini, defaults, WinWaitPID, 5
IniRead, useWinWaitCLASS, %A_ScriptDir%\ScriptEditor\ScriptEditor.ini, defaults, WinWaitCLASS, 2
IniRead, useWinWaitTITLE, %A_ScriptDir%\ScriptEditor\ScriptEditor.ini, defaults, WinWaitTITLE, 1
amplIcon = %amplDirectory%\AMPL.ico
;thisScript_Name=AMPL Script Updater
; Tray menu & icon
Menu, tray, icon, %amplIcon%

#include %A_ScriptDir%\ScriptEditor\includes\ScriptEditorFunctions.ahk

; Get the Includes Version
FileReadLine, lineTwo, %amplDirectory%\scripts\includes\AMPL_Includes.ahk, 2
if not ERRORLEVEL
{
  StringSplit, version, lineTwo, =,
  if (Version0 = 2)
  {
		if (Version1 = "version_AMPL_Includes")
		{
			version_AMPL_Includes_Installed:=Version2
		}
	}
}
 else
{
  MsgBox, Can't find Includes!`nI'm not sure what that means yet... but give me time...
}
;MsgBox, AMPL Includes: %version_AMPL_Includes_Installed%
pathScripts:= amplDirectory . "\scripts\*.ahk"
doAll=0
doneOne=0
done=0
filesChecked=0
filesNeedindUpating=0
filesUpdated=0
fileList=
listViewList=
lvScripts=
SelectAll=1

Gosub, GetFiles

if filesNeedindUpating>0
{
Gui, Font, S12 CDefault Bold, Verdana
Gui, Add, Text, x64 y20 w h , %title_ScriptUpdate%
Gui, Font, NORM s8,
Gui, Add, Picture, x3 y3 w48 h48, %amplIcon%
gui, Add, Text, w300 , Installed version of AMPL: %version_AMPL_Includes_Installed%`nThe Scripts listed below were generated using a previous version of AMPL Function Library.`n`nSelect the scripts to update and click 'Process'.
gui, Add, ListView, x3 w300 h vlvScripts checked, Script Name|Version
Gui, Add, Button, gSelectAll w90 vbuttonSelectAll,DeSelect All
Gui, Add, Button,gProcessList w90 xp+105,Process
Gui, Add, Button,gReScan w90 xp+105,ReScan
gui, add, Text, x3 w300 h vMessageFrame, Waiting to start...
gui, add, progress, x3 w300 h vProgressBar
windowMainCreated=1
gosub, AddFiles
GUI, show,,%title_ScriptUpdate% (%version_ScriptUpdate%)

} else
	ExitApp
return

guiclose:
ExitApp
return

SelectAll:
if SelectAll=1
{
	SelectAll=0
	MakeCheck=-Check
	buttonText:="Select All"
	}
else
{
	SelectAll=1
	MakeCheck=Check
	buttonText:="DeSelect All"
}
LV_Modify(0, MakeCheck)
GuiControl, , buttonSelectAll, %buttonText%

Return
ProcessList:
  RowNumber=0
  FilesToProcess=0
  ;versionUsedAMPLIncludes:=version_AMPL_Includes_Installed
  GuiControl, , MessageFrame, Counting Files:
  Loop
  {
	  RowNumber := LV_GetNext(RowNumber, "C")
	  if not RowNumber
	    break
	 FilesToProcess+=1
  GuiControl, , MessageFrame, Counting Files: %FilesToProcess%
	}
	
  Loop
  {
	  RowNumber := LV_GetNext(RowNumber, "C")
	  if not RowNumber
	    break
	 GuiControl, , MessageFrame, Updating Script:
	 Update(RowNumber)
	}
	GuiControl, , MessageFrame, Completed! %FilesToProcess% of %filesNeedindUpating% Scripts Processed
  Gosub, ReScan
Return
Update(r) {
global fileList,amplDirectory,commandList
windowMainCreated=1
StringSplit, files, fileList, ~, 

thisScript := files%r%

filesUpdated+=1
commandList=              ; the command steps
StringReplace, thisBackUp, thisScript, .ahk, .bak
GuiControl, , MessageFrame, Updating Script: Creating Backup

Filecopy, %thisScript%, %thisBackUp%, 1
if ERRORLEVEL
{
  MsgBox, Failed to copy %thisScript%`nTo %thisBackUp%`nWorking Dir: %A_WORKINGDIR%
}
GuiControl, , MessageFrame, Updating Script: Loading Script
LoadFile(thisScript)
delIssue=0
FileDelete, %thisScript%
if ERRORLEVEL
  {
    Loop
     {
        MsgBox, 4, Error Problem, Error on Delete: %ERRORLEVEL%`n`nContinue?,20
        IfMsgBox, No
          ExitApp, 100
			  FileDelete, %thisScript%
     }
	}
scriptPath = %thisScript%
SplitPath, thisScript, , iniPath, , iniFile,
;SplitPath, InputVar, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
iniPath = %iniPath%\%iniFile%.ini
includePath = %ampldirectory%\scripts\includes\AMPL_Includes.ahk
GuiControl, , MessageFrame, Updating Script: Writing Script
WriteFiles(thisScript , iniPath , includePath, false)
}

ReScan:
Gosub, GetFiles
Gosub, AddFiles
SelectAll=1
GuiControl, , buttonSelectAll, DeSelect All
Return
AddFiles:
LV_Delete()
Loop, Parse, listViewList, |,
{
  if A_LOOPFIELD!=
  {
    StringSplit, scriptDetails, A_LOOPFIELD, ~,
  	LV_Add("+Check", scriptDetails1 , scriptDetails2 )
  }
}
LV_ModifyCol()
Return

GetFiles:
filesNeedindUpating=0
fileList=
listViewList=

Loop, %pathScripts%, 0, 0
{
	; Clear the Script
	filesChecked+=1
  version_UsedInScript=0.0.0
	Loop, Read, %A_LoopFileLongPath%,
	{
    IfInString, A_LOOPREADLINE, version_AMPL_Includes_Used=
    {
      StringSplit, includeVersion, A_LOOPREADLINE, =,
			if (includeVersion1 = "version_AMPL_Includes_Used")
			{
				version_UsedInScript:=includeVersion2
			}
			break
		}
	}
  ;MsgBox, Checking: %A_LoopFileLongPath%`nVersion: %version_UsedInScript%`nAMPL: %version_AMPL_Includes_Installed%
	if (version_UsedInScript<version_AMPL_Includes_Installed)
	{
	  filesNeedindUpating+=1
	  fileList:=fileList . A_LoopFileLongPath . "~"
	  listViewList:=listViewList . A_LOOPFILENAME . "~" . version_UsedInScript . "|"
    ;MsgBox, Added!!
	}
}
Return
